/*
(C) 1998 Patrick Lambert <drow@fastethernet.net>

This program is free software. You can use, distribute and modify it if
you let this legal note in all future versions, and if the program made
stays under free software. (see sscript.doc)

This program is distributed without ANY WARRANTY, without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR   
PURPOSE.

Latest version of Socket Script is always available from
http://devplanet.fastethernet.net/sscript.html
*/

#include <stdio.h>
char filename[255];

main(int argc, char *argv[])
{
 int os,type;
 char temp[255];
 if(argv[1]!=NULL)
 {
  if(!strcasecmp(argv[1],"linux-gui")) make_config(0,1,1,1,1,1,1,1,0,1,0);
  else if(!strcasecmp(argv[1],"freebsd-gui")) make_config(1,1,1,1,1,1,1,1,0,1,0);
  else if(!strcasecmp(argv[1],"solaris-gui")) make_config(2,1,1,1,1,1,1,1,0,1,0);
  else if(!strcasecmp(argv[1],"bsdos-gui")) make_config(3,1,1,1,1,1,1,1,0,1,0);
  else if(!strcasecmp(argv[1],"noflags-gui")) make_config(4,1,1,1,1,1,1,1,0,1,0);
  else if(!strcasecmp(argv[1],"linux-console")) make_config(0,0,1,1,1,1,1,1,0,1,0);
  else if(!strcasecmp(argv[1],"freebsd-console")) make_config(1,0,1,1,1,1,1,1,0,1,0);
  else if(!strcasecmp(argv[1],"solaris-console")) make_config(2,0,1,1,1,1,1,1,0,1,0);
  else if(!strcasecmp(argv[1],"bsdos-console")) make_config(3,0,1,1,1,1,1,1,0,1,0);
  else if(!strcasecmp(argv[1],"noflags-console")) make_config(4,0,1,1,1,1,1,1,0,1,0);
  else printf("WARNING: unknown option: %s\n",argv[1]);
 }
 printf("\n\nWelcome to the Socket Script Compiler configuration!\n\n");
 printf("You will now set the environment you want your script to be run.\nWhat executable binary do you want to name it? ");
 scanf("%s",filename);
 printf("Which platform are you on (choices: linux, freebsd, bsdos, solaris, noflags   If your platform isn't listed, use noflags) ?\n");
 scanf("%s",temp);
 if(temp==NULL)
 {
  printf("STOP: Unknown choice\n");
  exit(1);
 }
 if(!strcasecmp(temp,"linux")) os = 0;
 else if(!strcasecmp(temp,"freebsd")) os = 1;
 else if(!strcasecmp(temp,"solaris")) os = 2;
 else if(!strcasecmp(temp,"bsdos")) os = 3;
 else if(!strcasecmp(temp,"noflags")) os = 4;
 else { printf("STOP: Unknown choice\n"); exit(1); }
 printf("\n\nSocket Script can be run in one of 3 modes. Text-only mode; new look GTK graphical mode, if you have the GTK libraries installed on your system, as well as the X Window system; or old look, Motif style graphical mode, this will work if");
 printf(" you have the X Window system with default X libraries.\n");
 printf("\nWhich mode do you want to run SScript as?\n\n1 - New graphical look (requires the GTK library)\n2 - Old graphical look (only needs the defaults X libs)\n3 - Text-only mode\nYour choice? ");
 scanf("%s",temp);
 if(temp==NULL)   
 {
  printf("STOP: Unknown choice\n");
  exit(1);
 }
 if(!strcasecmp(temp,"1")) type = 2;
 else if(!strcasecmp(temp,"2")) type = 1;
 else if(!strcasecmp(temp,"3")) type = 0;
 else { printf("STOP: Unknown choice\n"); exit(1); }
 printf("Setting defaults...\nUsing gcc...\nTemp dir: .\nEditor: pico\nPerl: /usr/bin/perl\nTK: /usr/bin/wish\nLog file: ./sscript.log\n\n");
 make_config(os,type,1,1,1,1,1,1,0,1,0);
 exit(0);
}

int make_config(int os, int type, int o1, int o2, int o3, int o4, int o5, int o6, int o7, int o8, int o9)
{
 FILE *fd;
 fd=fopen("Makefile","w");
 printf("Creating Makefile\n");
 fputs("# Made with config\n",fd);
 fputs("CC = gcc\n",fd);
 fputs("CFLAGS = ",fd);
 if(os!=4) fputs("-O ",fd);
 if(os==0) fputs("-DRAWLINUX -DPOSIX ",fd);
 if(type==1) fputs("-I/usr/X11R6/include",fd);
 if(type==2) fputs("-I/usr/X11R6/include",fd);
 fputs("\nLIBS = ",fd);
 if(os==1) fputs("-lcrypt ",fd);
 if(os==2) fputs("-lsocket -lnsl ",fd);
 if(type==1) fputs("-L/usr/X11R6/lib -lXaw -lXmu -lXt -lSM -lICE -lXext -lX11",fd);
 if(type==2) fputs("-L/usr/X11R6/lib -lgtk -lgdk -lglib -lX11 -lXext -lm",fd);
 fputs("\n",fd);
 if(os==0) fputs("OBJS = src/gui-gtk.o src/sscript.o src/gui-tk.o src/utils.o src/ssdb.o src/rawlinux.o src/ssdb2.o src/makebin.o",fd);
 else fputs("OBJS = src/gui-gtk.o src/sscript.o src/gui-tk.o src/utils.o src/ssdb.o src/ssdb2.o src/makebin.o",fd);
 fputs("\n\nall:\n",fd);
 fputs("\t@echo \"Compiling... This may take a few minutes...\"\n",fd);
 fputs("\t$(CC) $(CFLAGS) -o src/makebin.o -c src/makebin.c\n",fd);
 fputs("\t$(CC) $(CFLAGS) -o src/gui-gtk.o -c src/gui-gtk.c\n",fd);
 fputs("\t$(CC) $(CFLAGS) -o src/sscript.o -c src/sscript.c\n",fd);
 fputs("\t$(CC) $(CFLAGS) -o src/gui-tk.o -c src/gui-tk.c\n",fd);
 fputs("\t$(CC) $(CFLAGS) -o src/ssdb.o -c src/ssdb.c\n",fd);
 fputs("\t$(CC) $(CFLAGS) -o src/ssdb2.o -c src/ssdb2.c\n",fd);
 fputs("\t$(CC) $(CFLAGS) -o src/utils.o -c src/utils.c\n",fd);
 if(os==0) fputs("\t$(CC) $(CFLAGS) -o src/rawlinux.o -c src/rawlinux.c\n",fd);
 fputs("\t$(CC) $(CFLAGS) $(LIBS) -o ",fd);
 fputs(filename,fd);
 fputs(" $(OBJS)\n",fd);
 fputs("\trm -f src/*.o\n",fd);
 fputs("install:\n",fd);
 fputs("\tcp sscript /usr/bin/sscript\n",fd);
 fputs("\tchmod +x /usr/bin/sscript\n",fd);
 fputs("\tcp docs/sscript.1 /usr/man/man1/sscript.1\n",fd);
 fputs("\tcp docs/sscript.doc /usr/info/sscript.doc\n\n",fd);
 fputs("install-man:\n",fd);
 fputs("\tcp docs/sscript.1 /usr/man/man1/sscript.1\n\n",fd);
 fputs("clean:\n",fd);
 fputs("\trm -f src/*.o\n",fd);
 fclose(fd);
 fd=fopen("src/config.h","w");
 printf("Creating config.h\n");
 fputs("/* Made with config */\n",fd);
 fputs("/* Change empty strings with <NO-STRING> */\n",fd);
 fputs("#define HANDLE_EMPTY_STRINGS\n",fd);
 fputs("/* Get remote IP when running a server-oriented script */\n",fd);
 fputs("#define GET_REMOTE_IP\n",fd);
 fputs("/* Fork on starting of server-oriented scripts */\n",fd);
 fputs("#define FORK_START\n",fd);
 fputs("#define IPFW \"/sbin/ipfwadm\"\n",fd);
 fputs("#define LOGFILE \"sscript.log\"\n",fd);
 fputs("#define CL_GUI_TK_PATH \"/usr/bin/wish\"\n",fd);
 fputs("#define PERL_BIN \"/usr/bin/perl\"\n",fd);
 fputs("/* This is the dir where SScript puts temp files. It should be onwed by you with read permission by you only */\n",fd);
 fputs("#define TEMP_DIR \".\"\n",fd);
 fputs("/* Show the header when starting SScript */\n",fd);
 fputs("#undef HEADER\n",fd);
 fputs("#define EDITOR \"pico\"\n",fd);
 fputs("/* Run in graphical mode */\n",fd);
 if(type==0) fputs("#undef GUI\n",fd);
 if(type==1) fputs("#define GUI\n",fd);
 if(type==2) fputs("#define GUI\n",fd);
 if(type==0) fputs("#undef GTK\n",fd);
 if(type==1) fputs("#undef GTK\n",fd);
 if(type==2) fputs("#define GTK\n",fd);
 fputs("/* define ONE of the following to set a custom GUI color set */\n",fd);
 fputs("#undef RES_STANDARD\n",fd);
 fputs("#define RES_3D\n",fd);
 fputs("#undef RES_COLORFUL\n",fd);
 printf("Done. You should be able to run 'make' now.\n");
 exit(0);
 return 0;
}
