/*
(C) 1998 Patrick Lambert <drow@fastethernet.net>

This program is free software. You can use, distribute and modify it if
you let this legal note in all future versions, and if the program made
stays under free software. (see sscript.doc)

This program is distributed without ANY WARRANTY, without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.

Latest version of Socket Script is always available from
http://devplanet.fastethernet.net/sscript.html
*/

#define VERSION 111
#ifndef FNDELAY
#define FNDELAY O_NONBLOCK
#endif
#include "sscript.h"
#ifdef RAWLINUX
#include <linux/kernel.h>
#include <linux/sys.h>
#endif
#include <syslog.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <sys/file.h>
#ifdef POSIX
#include <pwd.h>
#include <sys/utsname.h>
#endif
#include <signal.h>
#include <errno.h>
#include <unistd.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/stat.h>
#ifndef IPPROTO_IP
#define IPPROTO_IP 0
#endif
#ifdef GUI
#ifndef GTK
#include <malloc.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Dialog.h>  
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Simple.h>
#include <X11/Xaw/SmeLine.h>
#define SetArg(which, val)      XtSetArg(args[nargs], (which),\
                                         (XtArgVal) (val)); nargs++
Widget  toplevel, top, top6, top3, top4, top5;
Screen  *screen;
Display *display[7];
XtAppContext ac, ac2, ac3, ac4, ac5, ac6;
XEvent event, qevent;
int displayed=0;

static Widget msgwidget, textbox, last, entrybox, mainbox, dialog1, okbutton, quitbutton, continuebutton, viewbox;
static Widget form, widgets[3], choicebutton[10], form, menu, menubutton1, menubutton2, menubutton3, menubutton4, menubutton5, menubutton6, menubutton7, menubutton8, menubutton9, menubutton10, entry;

/* GUI resource file */
static String sscript_resources[] = {
    "*resizeGravity: NorthWest",
    "*beNiceToColormap: false",
    "*topShadowContrast: 20",
    "*bottomShadowContrast: 40",
#ifdef RES_COLORFUL
    "*textbox*background: #503080",
    "*textbox*foreground: #FFAAFF",
    "*textbox*shadowWidth: 2",
    "*viewbox*shadowWidth: 2",
    "*dialog1*font: *-*-bold-i-*-*-14-*-*-*-*-*-*-*",
    "*text*font: *-*-bold-*-*-*-12-*-*-*-*-*-*-*",
    "*foreground: #AA2050",
    "*background: LightGray",
    "*viewbox*foreground: #000050",
    "*viewbox*background: #FFFFFF",
    "*Label*foreground: #050505",
#endif
#ifdef RES_STANDARD
    "*textbox*shadowWidth: 0",
    "*viewbox*shadowWidth: 0",
    "*foreground: #000000", 
    "*background: #FFFFFF",
#endif
#ifdef RES_3D
    "*textbox*foreground: #503080",
    "*textbox*shadowWidth: 2",
    "*viewbox*shadowWidth: 2",
    "*dialog1*font: *-*-bold-i-*-*-12-*-*-*-*-*-*-*",
    "*foreground: NavyBlue",
    "*background: LightGray",
    "*viewbox*foreground: #000000",
    "*viewbox*background: #FFFFFF",
    "*Label*foreground: #050505",
#endif
    NULL
};

#endif /* gtk */
#endif /* gui */

/* signal handling */
void handle_segv()
{
 char templog[512];
 sprintf(templog,"[%ld] Segmentation fault while processing [%s] [pid=%d]\n",time(NULL),temp,pid);
 appendlog(templog);
#ifdef GUI
 if(lang==0)
 sprintf(templog,"Internal error: Segmentation fault. I suggest you check your script for any typos.\nerrno=%d currently processing=%s pid=%d",errno,temp,pid);
 else if(lang==1)
 sprintf(templog,"Erreur interne: Erreur de protection de memoire. Vous devriez verifier votre script pour des erreurs possibles.");
 else if(lang==2)
 sprintf(templog,"Error Interno: Falla en Segmentacin. Sugiero que cheques tu script para ver si no hay errores en ortografa.");
 if(!set_signals_off) {
#ifndef GTK
 XFlush(display[2]);
#endif
  msgbox("error",templog,strlen(templog)); }
#else
 if(lang==0)
 {
 if(!set_signals_off) printf("*** Internal error: Segmentation fault. I suggest you check your script for any typos. If the problem is an internal bug, please contact the author.\nerrno=%d\ncurrently processing=%s\npid=%d\n",errno,temp,pid);
 }
 else if(lang==1)
 {
 if(!set_signals_off) printf("*** Erreur interne: Erreur de protection de memoire. Vous devriez verifier votre script pour des erreurs possibles.\n");
 }
 else if(lang==2)
 {
 if(!set_signals_off) printf("*** Error Interno: Falla en Segmentacin. Sugiero que cheques tu script para ver si no hay errores en ortografa.\n");
 }
#endif
 if(strcasecmp(cron,"")) system(cron);
 exit(1);
}

void handle_hup()
{
 char templog[512];
 sprintf(templog,"[%ld] Hangup while processing [%s] [pid=%d]\n",time(NULL),temp,pid);
 appendlog(templog);
#ifdef GUI
 if(lang==0)
 sprintf(templog,"Internal error: Hangup. Someone kill'ed -HUP this program... [pid=%d]",pid);
 else if(lang==1)
 sprintf(templog,"Erreur interne: Hangup. Quelqu'un a tuer votre script...");
 else if(lang==2)
 sprintf(templog,"Error Interno: Hangup.");
 if(!set_signals_off) { 
#ifndef GTK
 XFlush(display[2]);
#endif
  msgbox("error",templog,strlen(templog)); }
#else
 if(lang==0)
 {
 if(!set_signals_off) printf("*** Internal error: Hangup. Someone kill'ed -HUP this program... [pid=%d]\n",pid);
 }
 else if(lang==1)
 {
 if(!set_signals_off) printf("*** Erreur interne: Hangup. Quelqu'un a tuer votre script...\n");
 }
 else if(lang==2)
 {
 if(!set_signals_off) printf("*** Error Interno: Hangup.\n");
 }
#endif
 if(strcasecmp(cron,"")) system(cron);
 exit(1);
}

void handle_int()
{
 char templog[512];
 sprintf(templog,"[%ld] Interrupt while processing [%s] [pid=%d]\n",time(NULL),temp,pid);
 appendlog(templog);
#ifdef GUI
 if(lang==0)
 sprintf(templog,"Internal error: Interrupt. Exiting... [pid=%d]",pid);
 else if(lang==1)
 sprintf(templog,"Erreur interne: Interrupt. Sort... [pid=%d]",pid);
 else if(lang==2)
 sprintf(templog,"Error Interno: Interrupcin. Saliendo... [pid=%d]",pid);
 if(!set_signals_off) msgbox("error",templog,strlen(templog));
#else
 if(lang==0)
 {
 if(!set_signals_off) printf("*** Internal error: Interrupt. Exiting... [pid=%d]\n",pid);
 }
 else if(lang==1)
 {
 if(!set_signals_off) printf("*** Erreur interne: Interrupt. Sort... [pid=%d]\n",pid);
 }
 else if(lang==2)
 {
 if(!set_signals_off) printf("*** Error Interno: Interrupcin. Saliendo... [pid=%d]\n",pid);
 }
#endif
 if(strcasecmp(cron,"")) system(cron);
 exit(1);
}

void handle_pipe()
{
 char templog[512];
 sprintf(templog,"[%ld] Broken pipe while processing [%s] [pid=%d]\n",time(NULL),temp,pid);
 appendlog(templog);
#ifdef GUI
 if(lang==0)
 sprintf(templog,"Internal error: Broken pipe. I tried to write when the connection was off [pid=%d]",pid);
 else if(lang==1)
 sprintf(templog,"Erreur interne: Connection ferme. J'ai essaye d'ecrire quand la connection etait ferme.");
 else if(lang==2)
 sprintf(templog,"Error Interno: Pipa rota. Trat de escribir cuando la conexion estaba");
 if(!set_signals_off) { 
#ifndef GTK
 XFlush(display[2]);
#endif
  msgbox("error",templog,strlen(templog)); }
#else
 if(lang==0)
 {
 if(!set_signals_off) printf("*** Internal error: Broken pipe. I tried to write when the connection wasn't established [pid=%d].\n",pid);
 }
 else if(lang==1)
 {
 if(!set_signals_off) printf("*** Erreur interne: Connection ferme. J'ai essaye d'ecrire quand la connection etait ferme.\n");
 }
 else if(lang==2)
 {
 if(!set_signals_off) printf("*** Error Interno: Pipa rota. Trat de escribir cuando la conexion estaba\n");
 }
#endif
 if(strcasecmp(cron,"")) system(cron);
 exit(1);
}

void handle_bus()
{
 char templog[512];
 sprintf(templog,"[%ld] Bus error while processing [%s] [pid=%d]\n",time(NULL),temp,pid);
 appendlog(templog);
#ifdef GUI
 if(lang==0)
 sprintf(templog,"Internal error: Bus error [pid=%d]",pid);
 else if(lang==1)
 sprintf(templog,"Erreur interne: Erreur du bus [pid=%d]",pid);
 else if(lang==2)
 sprintf(templog,"Error Interno: Bus error [pid=%d]",pid);
 if(!set_signals_off) { 
#ifndef GTK
 XFlush(display[2]);
#endif
 msgbox("error",templog,NULL,0); }
#else
 if(lang==0)
 {
 if(!set_signals_off) printf("*** Internal error: Bus error [pid=%d].\n",pid);
 }
 else if(lang==1)
 {
 if(!set_signals_off) printf("*** Erreur interne: Erreur du bus [pid=%d]\n",pid);
 }
 else if(lang==2)
 {
 if(!set_signals_off) printf("*** Error Interno: Bus error [pid=%d]\n",pid);
 }
#endif
 if(strcasecmp(cron,"")) system(cron);
 exit(1);
}

char *info(int i)
{
#ifdef RAWLINUX
 char data[255];
 struct sysinfo s_info;
 sysinfo(&s_info);
 sprintf(data,"%ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld",s_info.uptime,s_info.loads[0],s_info.loads[1],s_info.loads[2],s_info.totalram,s_info.freeram,s_info.sharedram,s_info.bufferram,s_info.totalswap,s_info.freeswap,s_info.procs);
 strcpy(global_var,data);
 return (char *)global_var;
#endif
} 

char *lindex(char *input_string, int word_number)
{
 char *tokens[1024];
 static char tmpstring[1024];
 int i;
 strcpy(tmpstring,input_string);
 tokens[i=0] = strtok(tmpstring, " ");
 while ((tokens[++i] = strtok(NULL, " ")));
 tokens[i] = NULL;
 return(tokens[word_number]);
}

int main(int argc, char *argv[])
{
 /* necessary variables */
 int j,sockfd=0,len,port,debug,res,lenght,i,chop,loop=1,userhost=0;
 int temp3,listen_len,sockfd2,result,server_oriented=0,is_a_service=0;
 int pain_in_the=0,reversechop=0,current_for,max_for,min_for,strictwrite=0;
 int goto_on=0,strictcheck=0,from_len,othersck,rsck=0,tracing=0;
 int windows=0, cnt, opt=1, inputchop=0;
 char server[50],buf[1024],inchar;
 char master[255],virtual[50],inall[1024],temp2[255],matching[1024];
 char nick[255],user[255],temp4[255],filename[255],subnumber[255];
 char remote_ip[50]="", include_files[4][255], setremoteecho=0;
 char in[1024][1024];
 struct sockaddr_in address;
 struct sockaddr_in listen_addr;
 struct sockaddr_in la;
 struct sockaddr_in from_addr;
 struct sockaddr_in other_addr;
 struct sockaddr_in r_addr;
 struct stat stat_buf;
#ifdef POSIX
 struct utsname unamebuf;
#endif
 time_t lt;
 FILE *fp, *fpa, *fpb, *fpaccess;
 set_signals_off=0;
 pid=0;
 fillin();
 lasterror=0;
 for(i=0;i<4;i++) { strcpy(include_files[i],""); }
 strcpy(cron,"");
 strcpy(logfilename,LOGFILE);
 strcpy(TMP_DIR,TEMP_DIR);
 if(getenv("TMP_DIR")!=NULL && strlen(getenv("TMP_DIR"))<50)
 strcpy(TMP_DIR,getenv("TMP_DIR"));
 if(getenv("TEMP_DIR")!=NULL && strlen(getenv("TEMP_DIR"))<50)
 strcpy(TMP_DIR,getenv("TEMP_DIR"));
 lang=0;
 /* multi-language support */
 if(getenv("LANG")!=NULL)
 {
  if(!strcasecmp(getenv("LANG"),"french")) lang=1;
  if(!strcasecmp(getenv("LANG"),"francais")) lang=1;
  if(!strcasecmp(getenv("LANG"),"spanish")) lang=2;
  if(!strcasecmp(getenv("LANG"),"espanol")) lang=2;
 }
 if(argv[1]!=NULL)
 if(!strcasecmp(argv[1],"-version") || !strcasecmp(argv[1],"-help"))
 {
  printf("%s script using Socket Script 1.11 (compiled with SSC v0.2)\n",scriptname);
  exit(0);
 }
 sline=0;
#ifdef GUI /* GUI init */
#ifndef GTK
 /* initialization for GUI functions. This is a workaround, don't base
  * yourself on this.
  * Now here I tried lots of ways, like only 1 ac, or ac's destroyed and
  * recreated every time, but this is the only way I can get it without
  * a bunch of BadCursor on X_CreateWidget. Any other idea? mail me
  * about it.*/
 toplevel = XtAppInitialize(&ac2, "SScript", NULL, 0, &argc, argv,sscript_resources, NULL, 0);
 if(toplevel<0) lasterror=102;
 display[2] = XtDisplay(toplevel);
 screen = XtScreen(toplevel);
 top = XtVaAppInitialize(&ac, "SScript", NULL, 0, &argc, argv, sscript_resources, XtNtitle, "Socket Script", NULL);
 display[1] = XtDisplay(top);
 top6 = XtVaAppInitialize(&ac6, "SScript", NULL, 0, &argc, argv, sscript_resources, XtNtitle, "Socket Script", NULL);
 display[6] = XtDisplay(top6);
 top3 = XtVaAppInitialize(&ac3, "SScript", NULL, 0, &argc, argv,sscript_resources, XtNtitle, "Socket Script", NULL);
 display[3] = XtDisplay(top3);
 top4 = XtVaAppInitialize(&ac4, "SScript", NULL, 0, &argc, argv, sscript_resources, XtNtitle, "Socket Script", NULL);
 display[4] = XtDisplay(top4);
 top5 = XtVaAppInitialize(&ac5, "SScript", NULL, 0, &argc, argv, sscript_resources, XtNtitle, "Socket Script", NULL);
 display[5] = XtDisplay(top5);
#endif /* gtk */
#ifdef GTK
 gtk_init(&argc, &argv);
#endif /* gtk */
#ifdef HEADER
#ifndef GTK
 XFlush(display[2]);
#endif
 if(lang==0)
 msgbox("header","Socket Script v1.11 by Drow <drow@wildstar.net>\n",50);
 else if(lang==1)
 msgbox("header","Socket Script v1.11 par Drow <drow@wildstar.net>\n",50);
 else if(lang==2)
 msgbox("header","Script de Socket v1.11 por Drow <drow@wildstar.net>\n",50);
 if(!strcasecmp(filename,"-version")) exit(0);
#endif /* header */
#else /* text only */
#ifdef HEADER
 if(lang==0)
 printf("\nSocket Script v1.11 by Drow <drow@wildstar.net>\nLoading script...\n");
 else if(lang==1)
 printf("\nSocket Script v1.11 par Drow <drow@wildstar.net>\nOverture du script...\n");
 else if(lang==2)
 printf("\nSocket Script v1.11 por Drow <drow@wildstar.net>\nCargando script...\n");
 if(!strcasecmp(filename,"-version")) exit(0);
#endif /* header */
#endif /* gui / text-only */
 strcpy(filename,scriptname);
 sprintf(temp4,"[%ld] SScript starting: %s\n",time(NULL),filename);
 appendlog(temp4);
 if(script[sline]==NULL)
 {
#ifdef GUI
#ifndef GTK
  XFlush(display[2]);
#endif
  if(lang==0)
  msgbox("error","Script error: No header.",25);
  else if(lang==1)
  msgbox("error","Erreur script: Pas d'entete.",25);
  else if(lang==2)
  msgbox("error","Error en Script: no hay titulo.",25);
#else
  if(lang==0)
  fprintf(stderr,"*** Script error: No header.\n");
  else if(lang==1)
  fprintf(stderr,"*** Erreur script: Pas d'entete.\n");
  else if(lang==2)
  fprintf(stderr,"*** Error en Script: no hay titulo.\n");
#endif
  exit(1);
 }
 strcpy(temp,script[sline]);
 sline++;  /* 0->1 */
 if(strcasecmp(lindex(temp,0),"server"))
 {
#ifdef GUI
#ifndef GTK
  XFlush(display[2]);
#endif
  if(lang==0)
  msgbox("error","Script error: Script must start with server <ip>.",45);
  else if(lang==1)
  msgbox("error","Erreur script: Le script doit commencer avec server <ip>.",45);
  else if(lang==2)
  msgbox("error","Error en Script: Script debe empezar con servidor <ip>.",45);
#else
  if(lang==0)
  fprintf(stderr,"*** Script error: Script must start with server <ip>.\n");
  else if(lang==1)
  fprintf(stderr,"*** Erreur script: Le script doit commencer avec server <ip>.\n");
  else if(lang==2)
  fprintf(stderr,"*** Error en Script: Script debe empezar con servidor <ip>.\n");
#endif
  exit(1);
 }
 strcpy(server,(char *)lindex(temp,1));
 if(script[sline]==NULL)
 {
#ifdef GUI
#ifndef GTK
  XFlush(display[2]);
#endif
  if(lang==0)
  msgbox("error","Script error: Expected port <port> and got EOF.",45);
  else if(lang==1)
  msgbox("error","Erreur script: Attendais port <port>.",45);
  else if(lang==2)
  msgbox("error","Error en Script: puerto esperado <port>.",45);
#else
  if(lang==0)
  fprintf(stderr,"*** Script error: Expected port <port> and got EOF.\n");
  else if(lang==1)
  fprintf(stderr,"*** Erreur script: Attendais port <port>.\n");
  else if(lang==2)
  fprintf(stderr,"*** Error en Script: puerto esperado <port>.\n");
#endif
  exit(1);
 }
 strcpy(temp,script[sline]);
 sline++; /* 1->2 */
 if(strcasecmp(lindex(temp,0),"port"))
 {
#ifdef GUI
#ifndef GTK
  XFlush(display[2]);
#endif
  if(lang==0)
  msgbox("error","Script error: Expected port <port>.",30);
  else if(lang==1)
  msgbox("error","Erreur script: Attendais port <port>.",45);
  else if(lang==2)
  msgbox("error","Error en Script: puerto esperado <port>.",45);
#else
  if(lang==0)
  fprintf(stderr,"*** Script error: Expected port <port>.\n");
  else if(lang==1)
  fprintf(stderr,"*** Erreur script: Attendais port <port>.\n");
  else if(lang==2)
  fprintf(stderr,"*** Error en Script: puerto esperado <port>.\n");
#endif
  exit(1);
 }
 port = atoi(lindex(temp,1));
 if(script[sline]==NULL)
 {
#ifdef GUI
#ifndef GTK
  XFlush(display[2]);
#endif
  if(lang==0)
  msgbox("error","Script error: Expected debug <mode> and got EOF.",45);
  else if(lang==1)
  msgbox("error","Erreur script: Attendais debug <mode>.",45);
  else if(lang==2)
  msgbox("error","Error en Script: esperado debug <moda>.",45);
#else
  if(lang==0)
  fprintf(stderr,"*** Script error: Expected debug <mode> and got EOF.\n");
  else if(lang==1)
  fprintf(stderr,"*** Erreur script: Attendais debug <mode>.\n");
  else if(lang==2)
  fprintf(stderr,"*** Error en Script: esperado debug <moda>.\n");
#endif
  exit(1);
 }
 strcpy(temp,script[sline]);
 sline++; /* 2->3 */ 
 if(strcasecmp(lindex(temp,0),"debug"))
 {
#ifdef GUI
#ifndef GTK
  XFlush(display[2]);
#endif
  if(lang==0)
  msgbox("error","Script error: Expected debug <mode>.",25);
  else if(lang==1)
  msgbox("error","Erreur script: Attendais debug <mode>.",45);  
  else if(lang==2)
  msgbox("error","Error en Script: esperado debug <moda>.",45);
#else
  if(lang==0)
  fprintf(stderr,"*** Script error: Expected debug <mode>.\n");
  else if(lang==1)
  fprintf(stderr,"*** Erreur script: Attendais debug <mode>.\n");
  else if(lang==2)
  fprintf(stderr,"*** Error en Script: esperado debug <moda>.\n");
#endif
  exit(1);
 }
 debug = atoi(lindex(temp,1));
 if(script[sline]==NULL)
 {
#ifdef GUI
#ifndef GTK
  XFlush(display[2]);
#endif
  if(lang==0)
  msgbox("error","Script error: Expected chop <mode> and got EOF.",45);
  else if(lang==1)
  msgbox("error","Erreur script: Attendais chop <mode>.",45);
  else if(lang==2)
  msgbox("error","Error en Script: Chop esperado <moda>.",45);
#else
  if(lang==0)
  fprintf(stderr,"*** Script error: Expected chop <mode> and got EOF.\n");
  else if(lang==1)
  fprintf(stderr,"*** Erreur script: Attendais chop <mode>.\n");
  else if(lang==2)
  fprintf(stderr,"*** Error en Script: Chop esperado <moda>.\n");
#endif
  exit(1);
 }
 strcpy(temp,script[sline]);
 sline++; /* 3->4 */
 if(strcasecmp(lindex(temp,0),"chop"))
 {
#ifdef GUI
#ifndef GTK
  XFlush(display[2]);
#endif
  if(lang==0)
  msgbox("error","Script error: Expected chop <mode>.",25);
  else if(lang==1)
  msgbox("error","Erreur script: Attendais chop <mode>.",45);
  else if(lang==2)
  msgbox("error","Error en Script: Chop esperado <moda>.",45);
#else
  if(lang==0)
  fprintf(stderr,"*** Script error: Expected chop <mode>.\n");
  else if(lang==1)
  fprintf(stderr,"*** Erreur script: Attendais chop <mode>.\n");
  else if(lang==2)
  fprintf(stderr,"*** Error en Script: Chop esperado <moda>.\n");
#endif
  exit(1);
 }
 chop = atoi(lindex(temp,1));
 if(script[sline]==NULL)
 {
#ifdef GUI
#ifndef GTK
  XFlush(display[2]);
#endif
  if(lang==0)
  msgbox("error","Script error: Expected virtual <ip> and got EOF.",45);
  else if(lang==1)
  msgbox("error","Erreur script: Attendais virtual <ip>.",45);
  else if(lang==2)
  msgbox("error","Error en Script: Virtual esperado <ip>.",45);
#else
  if(lang==0)
  fprintf(stderr,"*** Script error: Expected virtual <ip> and got EOF.\n");
  else if(lang==1)
  fprintf(stderr,"*** Erreur script: Attendais virtual <ip>.\n");
  else if(lang==2)
  fprintf(stderr,"*** Error en Script: Virtual esperado <ip>.\n");
#endif
  exit(1);
 }
 strcpy(temp,script[sline]);
 sline++; /* 4->5 */
 if(strcasecmp(lindex(temp,0),"virtual"))
 {
#ifdef GUI
#ifndef GTK
  XFlush(display[2]);
#endif
  if(lang==0)
  msgbox("error","Script error: Expected virtual <ip>.",25);
  else if(lang==1)
  msgbox("error","Erreur script: Attendais virtual <ip>.",45);  
  else if(lang==2)
  msgbox("error","Error en Script: Virtual esperado <ip>.",45);
#else
  if(lang==0)
  fprintf(stderr,"*** Script error: Expected virtual <ip>.\n");
  else if(lang==1)
  fprintf(stderr,"*** Erreur script: Attendais virtual <ip>.\n");
  else if(lang==2)
  fprintf(stderr,"*** Error en Script: Virtual esperado <ip>.\n");
#endif
  exit(1);
 }
 strcpy(virtual,(char *)lindex(temp,1));
 /* we don't show the following if in GUI mode */
#ifdef HEADER
#ifndef GUI
 if(lang==0)
 {
  if(strcasecmp(server,"0")) printf("Connecting to %s port %d\n",server,port);
  else printf("Listening to port %d\n",port);
  if(debug) printf("Debug mode ON\n");
  if(!debug) printf("Debug mode OFF\n");
 }
 else if(lang==1)
 {
  if(strcasecmp(server,"0")) printf("Branchement sur %s port %d\n",server,port);
  else printf("Ecoute sur %d...\n",port);
  if(debug) printf("Debug mode active\n");
  if(!debug) printf("Debug mode non active\n");
 }
 else if(lang==2)
 {
  if(strcasecmp(server,"0")) printf("Conectando a puerto %s %d\n",server,port);
  else printf("Escuchando al puerto %d...\n",port);
  if(debug) printf("Modo debug ACTIVADO\n");
  if(!debug) printf("Modo debug NON ACTIVADO\n");
 }
#endif /* text-only */
#endif /* header */
#ifdef FORK_START
 if(!strcasecmp(server,"0"))
 /* server-oriented script */
 if(pid=fork())
 {
#ifndef GUI
  if(lang==0)
  printf("Going into the background...[pid=%d]\n",pid);
  else if(lang==1)
  printf("Allant en arriere-plan...[pid=%d]\n",pid);
  else if(lang==2)
  printf("Yendo hacia la portada...[pid=%d]\n",pid);
#endif /* text-only */
  exit(0);
 }
#endif /* fork start */
 /* connecting */
 if(!strcasecmp(server,"no-connection"))
 { /* no-connection script */ }
 else if(strcasecmp(server,"0"))
 {
  /* client-oriented script */
  sockfd = socket(AF_INET, SOCK_STREAM, 0);
  if(sockfd<1)
  {
#ifdef GUI
#ifndef GTK
   XFlush(display[2]);
#endif
   if(lang==0)
   msgbox("error","Internal error: Socket failed.",25);
   else if(lang==1)
   msgbox("error","Erreur interne: Socket erreur.",25);
   else if(lang==2)
   msgbox("error","Error Interno: Fallo el Socket.",25);
#else
   if(lang==0)
   fprintf(stderr,"*** Internal error: Socket failed [%d].\n",errno);
   else if(lang==1)
   fprintf(stderr,"*** Erreur interne: Socket erreur. [%d].\n",errno);
   else if(lang==2)
   fprintf(stderr,"*** Error Interno: Fallo el Socket. [%d].\n",errno);
#endif
   exit(1);
  }
  address.sin_family = AF_INET;
  address.sin_addr.s_addr = inet_addr(server);
  address.sin_port = htons(port);
  len = sizeof(address);
  if(strcasecmp(virtual,"0"))
  {
   la.sin_family = AF_INET;
   la.sin_addr.s_addr = inet_addr(virtual);
   la.sin_port = 0;
   bind(sockfd, (struct sockaddr *)&la, sizeof(la));
  }
  result = connect(sockfd, (struct sockaddr *)&address, len);
  if(result==-1)
  {
#ifdef GUI
#ifndef GTK
   XFlush(display[2]);
#endif
   if(lang==0)
   msgbox("error","Script error: Can't connect to remote host.",30);
   else if(lang==1)
   msgbox("error","Erreur script: Incapable de me connecter.",30);
   else if(lang==2)
   msgbox("error","Error en Script: No se puede conectar a host remoto.",30);
#else
   if(lang==0)
   fprintf(stderr,"*** Script error: Can't connect to %s port %d [%d].\n",server,port,errno);
   else if(lang==1)
   fprintf(stderr,"*** Erreur script: Incapable de me connecter sur %s port %d [%d].\n",server,port,errno);
   else if(lang==2)
   fprintf(stderr,"*** Error en Script: No se puede conectar a host remoto %s %d [%d].\n",server,port,errno);
#endif
   exit(1);
  }
 }
 else
 {
  /* server-oriented script */
  server_oriented = 1;
  sockfd2 = socket(AF_INET, SOCK_STREAM, 0);
  if(sockfd2<1)
  {
#ifdef GUI
#ifndef GTK
   XFlush(display[2]);
#endif
   if(lang==0)
   msgbox("error","Internal error: Socket failed.",25);
   else if(lang==1)
   msgbox("error","Erreur interne: Socket erreur.",25);
   else if(lang==2)
   msgbox("error","Error Interno: Fallo el Socket.",25);
#else
   if(lang==0)
   fprintf(stderr,"*** Internal error: Socket failed [%d].\n",errno);
   else if(lang==1)
   fprintf(stderr,"*** Erreur interne: Socket erreur. [%d].\n",errno);
   else if(lang==2)
   fprintf(stderr,"*** Error Interno: Fallo el Socket. [%d].\n",errno);
#endif
   exit(1);
  }
  listen_addr.sin_family = AF_INET;
  listen_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  listen_addr.sin_port = htons(port);
  listen_len = sizeof(listen_addr); 
  if(geteuid()==0)
   setsockopt(sockfd2, SOL_SOCKET, SO_REUSEADDR, (char *) &opt, sizeof(int));
  /* ok how do you unlink something if the program gets kill'ed -5 ? */
  if(bind(sockfd2, (struct sockaddr *)&listen_addr, listen_len))
  {
#ifdef GUI
#ifndef GTK
   XFlush(display[2]);
#endif
   if(lang==0)
   msgbox("error","Internal error: Binding failed. Wait a few minutes and try again or recompile the server.",80);
   else if(lang==1)
   msgbox("error","Erreur interne: Erreur de l'attribution de l'addresse locale. Attendez quelque minutes et reessayez, ou recompilez le server.",80);
   else if(lang==2)
   msgbox("error","Error Interno: Union Fallo. Espera unos minutos y vuelve a intent ar o recompila el servidor.",80);
#else
   if(lang==0)
   fprintf(stderr,"*** Internal error: Binding failed. Wait a few minutes and try again or recompile the server.\n");
   else if(lang==1)
   fprintf(stderr,"*** Erreur interne: Erreur de l'attribution de l'addresse locale. Attendez quelque minutes et reessayez, ou recompilez le server.\n");
   else if(lang==2)
   fprintf(stderr,"*** Error Interno: Union Fallo. Espera unos minutos y vuelve a intent ar o recompila el servidor.\n");
#endif
   exit(1);
  }
  listen(sockfd2, 5);
  for(;;)
  {
   if(sockfd!=(int)NULL) close(sockfd);
   sockfd = accept(sockfd2, (struct sockaddr *)&address, &len);
   if(pid=fork()) break;
  }
#ifdef GET_REMOTE_IP
  from_len=sizeof(from_addr);
  memset(&from_addr, 0, sizeof(from_addr));
  if(getpeername(sockfd, (struct sockaddr *)&from_addr,&from_len) < 0)
  {
   sprintf(temp4,"[%ld] Connection from unknown host [pid=%d]\n",time(NULL),pid);
   appendlog(temp4);
  }
  else
  {
   sprintf(temp4,"[%ld] Connection from %s [pid=%d]\n",time(NULL),inet_ntoa(from_addr.sin_addr),pid);
   appendlog(temp4);
   strcpy(remote_ip,inet_ntoa(from_addr.sin_addr));
  }
#endif
 } /* main loop */
 signal(SIGSEGV, handle_segv);
 signal(SIGINT, handle_int);
 signal(SIGPIPE, handle_pipe);
 signal(SIGHUP, handle_hup);
 signal(SIGBUS, handle_bus);
 strcpy(in[0],"");
 for(i=0;argv[i]!=NULL;i++)
 {
  strcat(in[0],argv[i]);
  strcat(in[0]," ");
 }
 while(script[sline]!=NULL)
 {
  strcpy(temp,script[sline]);
  sline++;
  temp[strlen(temp)-1]=' ';
  if(lindex(temp,0)==NULL || lindex(temp,0)==NULL) continue;
  if(tracing) addtrace(lasterror);
  if(tracing) addtrace(-1);
  if(!strcasecmp(lindex(temp,0),"command"))
  {
   strcpy(temp4,in[atoi(lindex(temp,1))]);
   strcpy(temp,temp4);
  }
  if(!strcasecmp(lindex(temp,0),"encryptfile"))
  {
   des_file(1, in);
  }
  if(!strcasecmp(lindex(temp,0),"decryptfile"))
  {
   des_file(2, in);
  }
  if(!strcasecmp(lindex(temp,0),"setsignalsoff"))
  {
   set_signals_off=1;
  }
  if(!strcasecmp(lindex(temp,0),"setremoteecho"))
  {
   setremoteecho=1;
  }
#ifdef POSIX
  if(!strcasecmp(lindex(temp,0),"uname"))
  {
   uname(&unamebuf);
   sprintf(in[atoi(lindex(temp,1))],"%s %s %s %s %s %s ;",unamebuf.sysname,unamebuf.nodename,unamebuf.release,unamebuf.version,unamebuf.machine,unamebuf.domainname);
  }
#endif
  if(!strcasecmp(lindex(temp,0),"setwindows"))
  {
   windows=1;
  }
  if(!strcasecmp(lindex(temp,0),"settrace"))
  {
   fpa=fopen("trace.log","w");
   if(fpa!=NULL) fclose(fpa);
   tracing=1;
  }
  if(!strcasecmp(lindex(temp,0),"random"))
  {
   srandom(time(NULL));
   sprintf(in[atoi(lindex(temp,1))],"%d",random() % atoi(lindex2(temp,2)));
  }
  if(!strcasecmp(lindex(temp,0),"loop") && !strcasecmp(lindex(temp,1),"end"))
  {
   if(loop!=0)
   {
    strcpy(temp2,lindex(temp,2));
    sline=0;
    while(script[sline]!=NULL)
    {
     sline++;
     strcpy(temp,script[sline]);
     if(!strcasecmp(lindex(temp,0),"loop") && !strcasecmp(lindex(temp,1),"start") && !strcasecmp(lindex(temp,2),temp2))
     break;
    }
   }
   else
   {
    loop = 1;
   }
  }
  if(!strcasecmp(lindex(temp,0),"save"))
  {
   fpa=fopen(lindex(temp,2),"w");
   if(fpa==NULL || fileno(fpa)<0) lasterror=103;
   else
   {
    fputs(in[atoi(lindex(temp,1))],fpa);
    fputs("\n",fpa);
    if(fpa!=NULL) fclose(fpa);
   }
  }
  if(!strcasecmp(lindex(temp,0),"cron"))
  {
   strcpy(cron,lrange(temp,1));
  }
  if(!strcasecmp(lindex(temp,0),"setstrictcheck"))
  {
   strictcheck = 1;
  }
  if(!strcasecmp(lindex(temp,0),"setlogfile"))
  {
   strcpy(logfilename,lindex(temp,1));
  }
  if(!strcasecmp(lindex(temp,0),"setuserhost"))
  {
   userhost = 1;
  }
  if(!strcasecmp(lindex(temp,0),"setservice"))
  {
   is_a_service = 1;
  }
  if(!strcasecmp(lindex(temp,0),"exit"))
  {
   sprintf(temp4,"[%ld] Normal exit [pid=%d]\n",time(NULL),pid);
   appendlog(temp4);
   shutdown(sockfd,2);
   close(sockfd);
   if(strcasecmp(cron,"")) system(cron);
   exit(0);
  }
  if(!strcasecmp(lindex(temp,0),"goto"))
  {
   strcpy(subnumber,lindex(temp,1));
   sline=0;
   while(script[sline]!=NULL)
   {
    sline++;
    strcpy(temp,script[sline]);
    if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
   }
  }
  if(!strcasecmp(lindex(temp,0),"for"))
  {
   min_for=atoi(lindex(temp,2));
   max_for=atoi(lindex(temp,4));
   current_for=min_for;
  }
  if(!strcasecmp(lindex(temp,0),"endfor"))
  {
   if(current_for!=max_for)
   {
    current_for++;
    strcpy(temp4,lindex(temp,1));
    sline=0;
    while(script[sline]!=NULL)
    {
     strcpy(temp,script[sline]);
     if(!strcasecmp(lindex(temp,0),"for") && !strcasecmp(lindex(temp,1),temp4)) break;
     sline++;
    }
    sline++;
   }
  }
  if(!strcasecmp(lindex(temp,0),"nodelay"))
  {
   if(( i = fcntl(sockfd, F_GETFL, 0)) == -1);
   else if (fcntl(sockfd, F_SETFL, i | FNDELAY) == -1);
  }
  if(!strcasecmp(lindex(temp,0),"getenv"))
  {
   if(getenv(lindex2(temp,1))==NULL) lasterror=104;
   else
   strncpy(in[atoi(lindex(temp,2))],getenv(lindex2(temp,1)),1024);
  }
  if(!strcasecmp(lindex(temp,0),"lasterror"))
  {
   sprintf(in[atoi(lindex(temp,1))],"%d",lasterror);
  }
  if(!strcasecmp(lindex(temp,0),"clearlasterror"))
  {
   lasterror=0;
  }
  if(!strcasecmp(lindex(temp,0),"background"))
  {
   if(fork()) exit(0);
  }
  if(!strcasecmp(lindex(temp,0),"choicebox"))
  {
#ifdef GUI
   choicebox(argc, argv);
   strcpy(in[atoi(lindex(temp,1))],queryGlVar);
#else
   lasterror=105;
#endif
  }
  if(!strcasecmp(lindex(temp,0),"setowner"))
  {
   if(setuid(atoi(lindex(temp,1)))<0) lasterror=106;
  }
  if(!strcasecmp(lindex(temp,0),"run"))
  {
   system(in[atoi(lindex(temp,1))]);
  }
  if(!strcasecmp(lindex(temp,0),"append"))
  {
   fpa=fopen(lindex(temp,2),"a");
   if(fpa==NULL || fileno(fpa)<0) lasterror=103;
   else
   {
    fputs(in[atoi(lindex(temp,1))],fpa);
    fputs("\n",fpa);
    if(fpa!=NULL) fclose(fpa);
   }
  }
  if(!strcasecmp(lindex(temp,0),"remove"))
  {
   fpa=fopen(lindex(temp,2),"r");
   if(fpa==NULL || fileno(fpa)<0) lasterror=107;
   sprintf(temp2,"%s/.temp%ld.tmp",TMP_DIR,time(NULL));
   fpb=fopen(temp2,"w");
   if(fpb==NULL || fileno(fpb)<0) lasterror=103;
   else
   {
    while(fgets(temp4,255,fpa)!=NULL)
    if(strcasecmp(temp4,in[atoi(lindex(temp,1))])) fputs(temp4,fpb);
    if(fpb!=NULL) fclose(fpb);
    if(fpa!=NULL) fclose(fpa);
    sprintf(temp4,"mv %s %s\n",temp2,lindex(temp,2));
    system(temp4);
   }
  }
  if(!strcasecmp(lindex(temp,0),"rementry"))
  {
   fpa=fopen(lindex(temp,2),"r");
   if(fpa==NULL || fileno(fpa)<0) lasterror=107;
   sprintf(temp2,"%s/.temp%ld.tmp",TMP_DIR,time(NULL));
   fpb=fopen(temp2,"w");
   if(fpb==NULL || fileno(fpb)<0) lasterror=103;
   else
   {
    while(fgets(temp4,255,fpa)!=NULL)   
    if(strcasecmp(lindex(temp4,0),lindex2(in[atoi(lindex(temp,1))],0)))
     fputs(temp4,fpb);
    if(fpb!=NULL) fclose(fpb);
    if(fpa!=NULL) fclose(fpa);
    sprintf(temp4,"mv %s %s\n",temp2,lindex(temp,2));
    system(temp4);
   }
  }
  if(!strcasecmp(lindex(temp,0),"ask"))
  {
   gets(in[atoi(lindex(temp,1))]);
printf("[%s]%d\n",in[atoi(lindex(temp,1))],atoi(lindex(temp,1)));
  }
  if(!strcasecmp(lindex(temp,0),"set"))
  {
   bzero(buf,1024);
   strcpy(buf,"");
   for(i=2;lindex(temp,i)!=NULL;i++)
   {
    if(reversechop) strcat(buf," ");
    if(*lindex(temp,i)=='$')
    {
     if(*(lindex(temp,i)+1)=='w')
     {
      i++;
      if(lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1)))!=NULL)
      strcat(buf,lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
      i++;
     }
     if(*(lindex(temp,i)+1)=='1') { sleep(1); }
     if(*(lindex(temp,i)+1)=='$') { strcat(buf,"$"); }
     if(*(lindex(temp,i)+1)=='\\') { strcat(buf,"\002"); }
     if(*(lindex(temp,i)+1)=='/')
     {
      i++;
      if(*(lindex(temp,i))=='0') strcat(buf,"\000");
      if(*(lindex(temp,i))=='1') strcat(buf,"\001");
      if(*(lindex(temp,i))=='2') strcat(buf,"\002");
      if(*(lindex(temp,i))=='3') strcat(buf,"\003");
      if(*(lindex(temp,i))=='4') strcat(buf,"\004");
      if(*(lindex(temp,i))=='5') strcat(buf,"\005");
      if(*(lindex(temp,i))=='6') strcat(buf,"\006");
      if(*(lindex(temp,i))=='7') strcat(buf,"\007");
      if(*(lindex(temp,i))=='8') strcat(buf,"\008");
      if(*(lindex(temp,i))=='9') strcat(buf,"\009");
     }
     if(*(lindex(temp,i)+1)=='p')
     { sprintf(temp4,"%d",pid); strcat(buf,temp4); }
     if(*(lindex(temp,i)+1)=='t')
     {
      lt=time(NULL);
      strcpy(temp4,ctime(&lt));
      temp4[strlen(temp4)-1]=' ';
      strcat(buf,temp4);
     }
     if(*(lindex(temp,i)+1)=='r')
     {
     }
     if(*(lindex(temp,i)+1)=='l') { strcat(buf,"\n"); }
     if(*(lindex(temp,i)+1)=='_') { strcat(buf," "); }
     if(*(lindex(temp,i)+1)=='%')
     {
      sprintf(temp4,"%d",current_for);
      strcat(buf,temp4);
     }
     if(*(lindex(temp,i)+1)=='2') { sleep(2); }
     if(*(lindex(temp,i)+1)=='3') { sleep(3); }
     if(*(lindex(temp,i)+1)=='g')
     {
      strcpy(subnumber,lindex(temp,(i+1)));
      sline=0;
      while(script[sline]!=NULL)
      {
       sline++;
       strcpy(temp,script[sline]);
       if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
      }
      goto_on = 1;
      break;
     }
     if(*(lindex(temp,i)+1)=='4') { sleep(4); }
     if(*(lindex(temp,i)+1)=='5') { sleep(5); }
     if(*(lindex(temp,i)+1)=='6') { sleep(6); }
     if(*(lindex(temp,i)+1)=='7') { sleep(7); }
     if(*(lindex(temp,i)+1)=='8') { sleep(8); }
     if(*(lindex(temp,i)+1)=='9') { sleep(9); }
     if(*(lindex(temp,i)+1)=='n')
     {
      strcat(buf,nick);  
     } 
     if(*(lindex(temp,i)+1)=='u')
     {
      strcat(buf,user);
     }
     if(*(lindex(temp,i)+1)=='e')
     {
      sprintf(temp4,"[%ld] Normal exit [pid=%d]\n",time(NULL),pid);
      appendlog(temp4);         
      shutdown(sockfd,2);
      close(sockfd);
      if(strcasecmp(cron,"")) system(cron);
      exit(0);
     }
     if(*(lindex(temp,i)+1)=='i')
     {
      i++;
      fpa=fopen(lindex(temp,i),"r");
      strcpy(temp2,"");
      for(j=0;j!=atoi(lindex(temp,(i+1)));j++)
       fgets(temp2,255,fpa);
      strcat(buf,temp2);
      if(fpa!=NULL) fclose(fpa);
      i++;
     }
     if(*(lindex(temp,i)+1)=='b')
     {
      goto_on = 1;
      loop = 0;
     }
     if(*(lindex(temp,i)+1)=='s')
     {
      i++;
      strcat(buf,lrange(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
      i++;
     }
    }   
    else
    {
     strcat(buf,lindex(temp,i));
    }
    if(!reversechop) strcat(buf," ");
   }
   strcpy(in[atoi(lindex(temp,1))],buf);
  }
  if(!strcasecmp(lindex(temp,0),"setstrictwrite"))
  {
   strictwrite=1;
  }
  if(!strcasecmp(lindex(temp,0),"setmaster"))
  {
   strcpy(master,lindex(temp,1));
  }
  if(!strcasecmp(lindex(temp,0),"file"))
  {
   if(!strcasecmp(lindex(temp,1),"access"))
   {
    if(fgets(in[atoi(lindex(temp,2))],255,fpaccess)==NULL) lasterror=121;
    else
    in[atoi(lindex(temp,2))][strlen(in[atoi(lindex(temp,2))])-1]=' ';
   }
   if(!strcasecmp(lindex(temp,1),"open"))
   {
    fpaccess=fopen(lindex2(in[atoi(lindex(temp,2))],0),"r");
    if(fpaccess==NULL || fileno(fpaccess)<0) lasterror=107;
   }
   if(!strcasecmp(lindex(temp,1),"exist"))
   {
    fpb=fopen(lindex2(in[atoi(lindex(temp,2))],0),"r");
    if(fpb==NULL) strcpy(in[atoi(lindex(temp,3))],"1 ;");
    else if(fileno(fpb)<0) strcpy(in[atoi(lindex(temp,3))],"1 ;");
    else strcpy(in[atoi(lindex(temp,3))],"0 ;");
    if(fpb!=NULL) fclose(fpb);
   }
   if(!strcasecmp(lindex(temp,1),"size"))
   {
    fpb=fopen(lindex2(in[atoi(lindex(temp,2))],0),"r");
    if(fpb==NULL || fileno(fpb)<0) lasterror=108;
    fstat(fileno(fpb), &stat_buf);
    sprintf(in[atoi(lindex(temp,3))],"%ld",stat_buf.st_size);
    if(fpb!=NULL) fclose(fpb);
   }
   if(!strcasecmp(lindex(temp,1),"mode"))
   {
    fpb=fopen(lindex2(in[atoi(lindex(temp,2))],0),"r");
    if(fpb==NULL || fileno(fpb)<0) lasterror=108;
    fstat(fileno(fpb), &stat_buf);
    sprintf(in[atoi(lindex(temp,3))],"%ld",stat_buf.st_mode);
    if(fpb!=NULL) fclose(fpb);
   }
   if(!strcasecmp(lindex(temp,1),"owner"))
   {
    fpb=fopen(lindex2(in[atoi(lindex(temp,2))],0),"r");
    if(fpb==NULL || fileno(fpb)<0) lasterror=108;
    fstat(fileno(fpb), &stat_buf);
    sprintf(in[atoi(lindex(temp,3))],"%d",stat_buf.st_uid);
    if(fpb!=NULL) fclose(fpb);
   }
   if(!strcasecmp(lindex(temp,1),"group"))
   {
    fpb=fopen(lindex2(in[atoi(lindex(temp,2))],0),"r");
    if(fpb==NULL || fileno(fpb)<0) lasterror=108;
    fstat(fileno(fpb), &stat_buf);
    sprintf(in[atoi(lindex(temp,3))],"%d",stat_buf.st_gid);
    if(fpb!=NULL) fclose(fpb);
   }
   if(!strcasecmp(lindex(temp,1),"mtime"))
   {
    fpb=fopen(lindex2(in[atoi(lindex(temp,2))],0),"r");
    if(fpb==NULL || fileno(fpb)<0) lasterror=108;
    fstat(fileno(fpb), &stat_buf);
    sprintf(in[atoi(lindex(temp,3))],"%ld",stat_buf.st_mtime);
    if(fpb!=NULL) fclose(fpb);
   }
   if(!strcasecmp(lindex(temp,1),"ctime"))
   {
    fpb=fopen(lindex2(in[atoi(lindex(temp,2))],0),"r");
    if(fpb==NULL || fileno(fpb)<0) lasterror=108;
    fstat(fileno(fpb), &stat_buf);
    sprintf(in[atoi(lindex(temp,3))],"%ld",stat_buf.st_ctime);
    if(fpb!=NULL) fclose(fpb);
   }
   if(!strcasecmp(lindex(temp,1),"atime"))
   {
    fpb=fopen(lindex2(in[atoi(lindex(temp,2))],0),"r");
    if(fpb==NULL || fileno(fpb)<0) lasterror=108;
    fstat(fileno(fpb), &stat_buf);
    sprintf(in[atoi(lindex(temp,3))],"%ld",stat_buf.st_atime);
    if(fpb!=NULL) fclose(fpb);
   }
  }
  if(!strcasecmp(lindex(temp,0),"binary-send"))
  {
   sprintf(temp4,"uuencode %s %s > %s/.temp.uue 2>/dev/null",lindex2(in[atoi(lindex(temp,1))],0),lindex2(in[atoi(lindex(temp,1))],0),TMP_DIR);
   system(temp4);
   sprintf(temp2,"%s/.temp.uue",TMP_DIR);
   fpa=fopen(temp2,"r");
   if(fpa==NULL || fileno(fpa)<0) lasterror=107;
   else {
    while((cnt = read(fileno(fpa), temp4, 250))>0)
     write(sockfd, temp4, cnt);
    if(fpa!=NULL) fclose(fpa);
    sprintf(temp4,"rm -f %s/.temp.uue",TMP_DIR);
    system(temp4);
   }
  }
  if(!strcasecmp(lindex(temp,0),"binary-get"))
  {
   sprintf(temp2,"%s/.temp.uue",TMP_DIR);
   fpa=fopen(temp2,"w");
   if(fpa==NULL || fileno(fpa)<0) lasterror=103;
   else {
    while(strcasecmp(inall,"end\n"))
    {
     bzero(inall, 1024);
     for(i=0;read(sockfd,&inchar,1)!='\0';i++)
     { 
      inall[i]=inchar;
      if(inchar=='\n') break;
     }
     if (chop) inall[i-1]=' ';
     if(debug) printf("[%d] [%s]\n",atoi(lindex(temp,1)),inall);
     fputs(inall,fpa);
    }
    if(fpa!=NULL) fclose(fpa);
    sprintf(temp4,"uudecode %s/.temp.uue",TMP_DIR);
    system(temp4);
    sprintf(temp4,"rm -f %s/.temp.uue",TMP_DIR);
    system(temp4);
   }
  }
  if(!strcasecmp(lindex(temp,0),"chdir"))
  {
   if(chdir(lindex2(in[atoi(lindex(temp,1))],0))<0) lasterror=120;
  }
  if(!strcasecmp(lindex(temp,0),"setinputchop"))
  {
   inputchop=1;
  }
  if(!strcasecmp(lindex(temp,0),"input"))
  {
   fpa=fopen(lindex2(in[atoi(lindex(temp,1))],0),"r");
   if(fpa==NULL || fileno(fpa)<0) lasterror=107;
   for(i=0;fgets(temp4,255,fpa)!=NULL;i++)
    if(i==atoi(in[atoi(lindex(temp,2))])) break;
   strcpy(in[atoi(lindex(temp,3))],temp4);
   if(inputchop) in[atoi(lindex(temp,3))][strlen(in[atoi(lindex(temp,3))])-1]=' ';
   if(fpa!=NULL) fclose(fpa);
  }
  if(!strcasecmp(lindex(temp,0),"dump"))
  {
   fpa=fopen(lindex2(in[atoi(lindex(temp,1))],0),"r");
   if(fpa==NULL || fileno(fpa)<0) lasterror=107;
   while((cnt = read(fileno(fpa), temp4, 250))>0)
    write(sockfd, temp4, cnt);
   if(fpa!=NULL) fclose(fpa);
  }
  if(!strcasecmp(lindex(temp,0),"devstat"))
  {
   strcpy(in[atoi(lindex(temp,2))],if_setup(lindex(temp,1)));
  }
  if(!strcasecmp(lindex(temp,0),"expr"))
  {
   if(!strcasecmp(lindex(temp,2),"+"))
   sprintf(in[atoi(lindex(temp,5))],"%ld",(atol(in[atoi(lindex2(temp,1))])+atol(in[atoi(lindex(temp,3))])));
   if(!strcasecmp(lindex(temp,2),"-"))
   sprintf(in[atoi(lindex(temp,5))],"%ld",(atol(in[atoi(lindex2(temp,1))])-atol(in[atoi(lindex(temp,3))])));
   if(!strcasecmp(lindex(temp,2),"*"))
   sprintf(in[atoi(lindex(temp,5))],"%ld",(atol(in[atoi(lindex2(temp,1))])*atol(in[atoi(lindex(temp,3))])));
   if(!strcasecmp(lindex(temp,2),"/"))
   sprintf(in[atoi(lindex(temp,5))],"%ld",(atol(in[atoi(lindex2(temp,1))])/atol(in[atoi(lindex(temp,3))])));
  }
  if(!strcasecmp(lindex(temp,0),"firewall"))
  {
   firewall();
  }
  if(!strcasecmp(lindex(temp,0),"varlenght"))
  {
   if(lindex(in[atoi(lindex2(temp,1))],0)==NULL)
   strcpy(in[atoi(lindex(temp,2))],"0");
   else
   sprintf(in[atoi(lindex(temp,2))],"%d",strlen(lindex2(in[atoi(lindex(temp,1))],0)));
  }
  if(!strcasecmp(lindex(temp,0),"sysinfo"))
  {
   strcpy(in[atoi(lindex(temp,1))],(char *)info(0));
  }
  if(!strcasecmp(lindex(temp,0),"constat"))
  {
   strcpy(in[atoi(lindex(temp,2))],(char *)constat(lindex(temp,1),sockfd));
  }
  if(!strcasecmp(lindex(temp,0),"parse"))
  {
   if(!strcasecmp(lindex(temp,1),"<<"))
   {
    for(i=0;(char)in[atoi(lindex(temp,2))][i]!=(char)NULL;i++)
    {
     if(in[atoi(lindex(temp,2))][i]==*lindex(temp,3)) break;
     in[atoi(lindex(temp,2))][i]=' ';
    }
   }
   if(!strcasecmp(lindex(temp,1),"<"))
   {
    for(i=0;(char)in[atoi(lindex(temp,2))][i]!=(char)NULL;i++)
    {
     if(in[atoi(lindex(temp,2))][i]==*lindex(temp,3)) break;
     in[atoi(lindex(temp,2))][i]=' ';
    }
    in[atoi(lindex(temp,2))][i]=' ';
   }
   if(!strcasecmp(lindex(temp,1),">"))
   {
    for(i=0;(char)in[atoi(lindex(temp,2))][i]!=(char)NULL;i++)
    { if(in[atoi(lindex(temp,2))][i]==*lindex(temp,3)) break; }
    for(i=i;(char)in[atoi(lindex(temp,2))][i]!=(char)NULL;i++)
    { in[atoi(lindex(temp,2))][i]=' '; }
   }
   if(!strcasecmp(lindex(temp,1),">>"))
   {
    for(i=0;(char)in[atoi(lindex(temp,2))][i]!=(char)NULL;i++)
    { if(in[atoi(lindex(temp,2))][i]==*lindex(temp,3)) break; }
    i++;
    for(i=i;(char)in[atoi(lindex(temp,2))][i]!=(char)NULL;i++)
    { in[atoi(lindex(temp,2))][i]=' '; }
   } 
   if(!strcasecmp(lindex(temp,1),"!"))
   {
    strcpy(temp4,"");
    for(i=0;lindex(in[atoi(lindex2(temp,2))],i)!=NULL;i++)
    {
     strcat(temp4,lindex(in[atoi(lindex2(temp,2))],i));
    }
    strcpy(in[atoi(lindex2(temp,2))],temp4);
   }
   if(!strcasecmp(lindex(temp,1),"_>"))
   {
    j=0;
    strcpy(inall,"");
    for(i=0;(char)in[atoi(lindex(temp,2))][i]!=(char)NULL;i++)
    {
     inall[j]=in[atoi(lindex(temp,2))][i];
     j++;
     if(in[atoi(lindex(temp,2))][i]==*lindex(temp,3))
     {
      inall[j]=' ';
      j++;
     }
    }
    strcpy(in[atoi(lindex(temp,2))],inall);
   }
   if(!strcasecmp(lindex(temp,1),"<_"))
   {
    j=0;
    strcpy(inall,"");
    for(i=0;(char)in[atoi(lindex(temp,2))][i]!=(char)NULL;i++)
    {
     if(in[atoi(lindex(temp,2))][i]==*lindex(temp,3))
     {
      inall[j]=' ';
      j++;
     }
     inall[j]=in[atoi(lindex(temp,2))][i];
     j++;
    }
    strcpy(in[atoi(lindex(temp,2))],inall);
   }
  }
  if(!strcasecmp(lindex(temp,0),"cl"))
  {
  /* these are only examples. The CL function has been made for people
     to be able to quickly add Custom Libraries without messing with the
     code too much. See the docs. */
   if(!strcasecmp(lindex(temp,1),"gui-tk"))
   {
    gui_tk_cl(sockfd,in);
   }
   else if(!strcasecmp(lindex(temp,1),"utils"))
   {
    utils_cl(sockfd,in);
   }
   else if(!strcasecmp(lindex(temp,1),"ssdb"))
   {
    ssdb_cl(sockfd,in);
   }
   else if(!strcasecmp(lindex(temp,1),"ssdb2"))
   {
    ssdb2_cl(in);
   }
/* ---------------------------------------------------------------- */
/* *****        CUSTOM LIBRARIES SHOULD BE ADDED HERE        ****** */
/* ---------------------------------------------------------------- */
   else
   {
    for(i=0;lindex(include_files[i],0)!=NULL;i++)
    {
     if(!strcasecmp(lindex(include_files[i],0),lindex2(temp,1)))
     {
      sprintf(temp4,"%s %s",lindex(include_files[i],1),temp);
      system(temp4);
     }
    }
   }
  }
  if(!strcasecmp(lindex(temp,0),"ping"))
  {
   othersck=socket(AF_INET, SOCK_STREAM, 0);
   if(othersck<0) lasterror=109;
   other_addr.sin_family = AF_INET;
   other_addr.sin_addr.s_addr = inet_addr(lindex(temp,1));
   other_addr.sin_port = htons(7);
   if(connect(othersck, (struct sockaddr*) &other_addr,sizeof(other_addr))<0) lasterror=110;
   temp3=write(othersck,"ping\n",strlen("ping\n"));
   temp3=read(othersck,temp4,temp3);
   close(othersck);
  }
  if(!strcasecmp(lindex(temp,0),"test"))
  {
   if((othersck=socket(AF_INET, SOCK_STREAM, 0))<0)
   {
    sprintf(in[atoi(lindex(temp,1))],"SOCKET FAILED: %s",strerror(errno));
    lasterror=109;
   }
   other_addr.sin_family = AF_INET;
   other_addr.sin_addr.s_addr = inet_addr(lindex2(in[atoi(lindex(temp,1))],0));
   other_addr.sin_port = htons(atoi(lindex2(in[atoi(lindex(temp,1))],1)));
   if(connect(othersck, (struct sockaddr*)&other_addr,sizeof(other_addr))==-1)
   {
    sprintf(in[atoi(lindex(temp,1))],"CONNECT FAILED: %s",strerror(errno));
    lasterror=110;
   }
   else strcpy(in[atoi(lindex(temp,1))],"0");
   close(othersck);
  }
  if(!strcasecmp(lindex(temp,0),"rdisconnect"))
  {
   shutdown(rsck,2);
   close(rsck);
  }
  if(!strcasecmp(lindex(temp,0),"rconnect"))
  {
   if((rsck=socket(AF_INET, SOCK_STREAM, 0))<0)
   {
    sprintf(in[atoi(lindex(temp,1))],"SOCKET FAILED: %s",strerror(errno));
    lasterror=109;
   }
   r_addr.sin_family = AF_INET;
   r_addr.sin_addr.s_addr = inet_addr(lindex2(in[atoi(lindex(temp,1))],0));
   r_addr.sin_port = htons(atoi(lindex2(in[atoi(lindex(temp,1))],1)));
   if(connect(rsck, (struct sockaddr*)&r_addr,sizeof(r_addr))==-1)
   {
    sprintf(in[atoi(lindex(temp,1))],"CONNECT FAILED: %s",strerror(errno));
    lasterror=110;
   }
   else strcpy(in[atoi(lindex(temp,1))],"0");
  }
  if(!strcasecmp(lindex(temp,0),"rread"))
  {
   bzero(in[atoi(lindex(temp,1))], 1024);
   for(i=0;(result=read(rsck,&inchar,1))!='\0';i++)
   {
    in[atoi(lindex(temp,1))][i]=inchar;
    if(inchar=='\n') break;
   }
   if(result==0) lasterror=122;   
   if (chop) in[atoi(lindex(temp,1))][i-1]=' ';
   in[atoi(lindex(temp,1))][i]=' ';
   if(lindex(in[atoi(lindex2(temp,1))],0)==NULL) strcpy(in[atoi(lindex2(temp,1))],"<NO-STRING>");
  }
  if(!strcasecmp(lindex(temp,0),"rwrite"))
  {
   bzero(buf,1024);
   strcpy(buf,"");
   if(rsck<1) lasterror=111;
   for(i=0;lindex(in[atoi(lindex2(temp,1))],i)!=NULL;i++)
   {
    if(reversechop) strcat(buf," ");
    strcat(buf,lindex(in[atoi(lindex2(temp,1))],i));
    if(!reversechop) strcat(buf," ");
   }
   if(!strictwrite)
   {
    if(windows) strcat(buf,"\r\n");
    else strcat(buf,"\n");
   }  
   else buf[strlen(buf)-1]='\n';
   if(goto_on) goto_on=0; else
   write(rsck, buf, strlen(buf));
   if(debug) printf(">>> %s\n",buf);
  }
  if(!strcasecmp(lindex(temp,0),"include"))
  {
   for(i=0;lindex(include_files[i],0)!=NULL;i++) { }
   sprintf(include_files[i],"%s %s ;",lindex(temp,1),lindex2(temp,2));
  }
  if(!strcasecmp(lindex(temp,0),"require-gui"))
  {
#ifndef GUI
   if(lang==0)
   printf("This script needs SScript to be compiled as a graphical application (GUI).\n");
   else if(lang==1)
   printf("Ce script a besoin que SScript soit compile comme application graphique.\n");
   else if(lang==2)
   printf("Este Script necesita SScript paea ser compilado como aplicacion grafica (GUI).\n");
   exit(1);
#endif
  }
  if(!strcasecmp(lindex(temp,0),"require"))
  {
   if(atoi(lindex(temp,1)) > VERSION)
   {
#ifdef GUI
#ifndef GTK
    XFlush(display[2]);
#endif
    if(lang==0)
    msgbox("error","This script requires a newer Socket Script version. You can find the latest SScript at http://devplanet.fastethernet.net/sscript.html",120); 
    else if(lang==1)
    msgbox("error","Ce script a besoin d'une version de Socket Script plus recente. Vous pouvez en trouver une a http://devplanet.fastethernet.net/sscript.html",120);
    else if(lang==2)
    msgbox("error","Este script necesita una version nueva de Socket Script. Puedes encontrar la mas nueva en http://devplanet.fastethernet.net/sscript.html",120);
#else
    if(lang==0)
    printf("This script requires a newer Socket Script version. You can find the latest SScript at http://devplanet.fastethernet.net/sscript.html\n");
    else if(lang==1)
    printf("Ce script a besoin d'une version de Socket Script plus recente. Vous pouvez en trouver une a http://devplanet.fastethernet.net/sscript.html\n");
    else if(lang==2)
    printf("Este script necesita una version nueva de Socket Script. Puedes encontrar la mas nueva en http://devplanet.fastethernet.net/sscript.html\n");
#endif
    exit(1);
   } 
  }
  if(!strcasecmp(lindex(temp,0),"version"))
  {
   if(lang==0)
   printf("SScript v1.11 by Drow <drow@wildstar.net>\n");
   else if(lang==1)
   printf("SScript v1.11 par Drow <drow@wildstar.net>\n");
   else if(lang==2)
   printf("SScript v1.11 por Drow <drow@wildstar.net>\n");
  }
  if(!strcasecmp(lindex(temp,0),"addlog"))
  {
   sprintf(temp4,"[%ld] %s\n",time(NULL),in[atoi(lindex(temp,1))]);
   appendlog(temp4);
  }
  if(!strcasecmp(lindex(temp,0),"udpsend"))
  {
   udp_send(in);
  }
  if(!strcasecmp(lindex(temp,0),"udplisten"))
  {
   udp_listen(in);
  }
  if(!strcasecmp(lindex(temp,0),"icmplisten"))
  {
   icmp_detect(in);
  }
  if(!strcasecmp(lindex(temp,0),"users"))
  {
   users(in);
  }
  if(!strcasecmp(lindex(temp,0),"resolve"))
  {
   resolve(in);
  }
  if(!strcasecmp(lindex(temp,0),"raw"))
  {
#ifdef RAWLINUX
   raw_linux(in,1);
#else
   lasterror=112;
#endif
  }
  if(!strcasecmp(lindex(temp,0),"rawp"))
  {
#ifdef RAWLINUX   
   raw_linux(in,0);
#else
   lasterror=112;
#endif
  }
  if(!strcasecmp(lindex(temp,0),"read"))
  {
   bzero(in[atoi(lindex(temp,1))], 1024);
   for(i=0;(result=read(sockfd,&inchar,1))!='\0';i++)
   {
    in[atoi(lindex(temp,1))][i]=inchar;
    if(inchar=='\n') break;
   }
   if(result==0) lasterror=122;
   if(setremoteecho) write(sockfd,in[atoi(lindex(temp,1))],sizeof(in[atoi(lindex(temp,1))]));
   if (chop) in[atoi(lindex(temp,1))][i-1]=' ';
   in[atoi(lindex(temp,1))][i]=' ';
#ifdef HANDLE_EMPTY_STRINGS
   /* to prevent SIGSEVG on empty input */
   if(strlen(in[atoi(lindex(temp,1))])<3)
   {
    strcpy(in[atoi(lindex(temp,1))],"<NO-STRING>");
   }
   if(lindex2(in[atoi(lindex(temp,1))],0)==NULL)
   {
    strcpy(in[atoi(lindex(temp,1))],"<NO-STRING>");
   }
#endif
   if(strictcheck)
   {
    if(!strcasecmp(in[atoi(lindex(temp,1))],"") || !strcasecmp(in[atoi(lindex(temp,1))],"\n") || !strcasecmp(in[atoi(lindex(temp,1))],"\0"))
    {
     strcpy(in[atoi(lindex(temp,1))],"<NO-STRING>");
    }
   }
   if(!result && server_oriented)
   { 
    sprintf(temp4,"[%ld] Normal exit [pid=%d]\n",time(NULL),pid);
    appendlog(temp4);         
    shutdown(sockfd,2);
    close(sockfd);
    if(strcasecmp(cron,"")) system(cron);
    exit(0);
   }
   if(debug) printf("[%d] [%s]\n",atoi(lindex(temp,1)),in[atoi(lindex(temp,1))]);
   if(userhost)
   {
    if(lindex(in[atoi(lindex(temp,1))],0)!=NULL) strcpy(temp4,lindex(in[atoi(lindex(temp,1))],0));
    bzero(nick,255);
    bzero(user,255);
    strcpy(nick,"");
    strcpy(user,"");
    if(is_a_service)
    {
     strcpy(nick,temp4);
     nick[0]=' ';
    }
    if(strchr(temp4,'!')!=NULL)
    {
     j=0;
     for(i=1;temp4[i]!='!';i++)
     {
      nick[j]=temp4[i];
      j++;
     }
     j=0;
     for(i=(i+1);(char)temp4[i]!=(char)NULL;i++)
     {
      user[j]=temp4[i];
      j++;
     }
    }
   }
  }
  if(!strcasecmp(lindex(temp,0),"saveall"))
  {
   fpa=fopen(lindex(temp,1),"a");
   if(fpa==NULL || fileno(fpa)<0) lasterror=103;
   while(strcasecmp(inall," "))
   {
    bzero(inall, 1024);
    for(i=0;read(sockfd,&inchar,1)!='\0';i++)
    {
     inall[i]=inchar;
     if(inchar=='\n') break;
    }
    if (chop) inall[i-1]=' ';
    inall[i]=' ';
    if(debug) printf("[%d] [%s]\n",atoi(lindex(temp,1)),inall);
    fputs(inall,fpa);
    fputs("\n",fpa);
   }
   if(fpa!=NULL) fclose(fpa);
  }
  if(!strcasecmp(lindex(temp,0),"wait")) sleep(1);
  if(!strcasecmp(lindex(temp,0),"ifmaster"))
  {
   if(!strcasecmp(lindex(temp,3),lindex2(in[atoi(lindex(temp,1))],atoi(lindex(temp,2)))))
   {
    fpa=fopen(master,"r");
    while(fgets(temp2,255,fpa)!=NULL)
    {
     if(!match(lindex2(temp2,0),lindex(in[atoi(lindex(temp,1))],0)))
     {
      bzero(buf,1024);
      strcpy(buf,"");
      for(i=4;lindex(temp,i)!=NULL;i++)
      {
       if(reversechop) strcat(buf," ");
       if(*lindex(temp,i)=='$')
       {
        if(*(lindex(temp,i)+1)=='w')
        {
         i++;
         if(lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1)))!=NULL)
         strcat(buf,lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
         i++;
        }
        if(*(lindex(temp,i)+1)=='1') { sleep(1); }
        if(*(lindex(temp,i)+1)=='2') { sleep(2); }
        if(*(lindex(temp,i)+1)=='$') { strcat(buf,"$"); }
        if(*(lindex(temp,i)+1)=='\\') { strcat(buf,"\002"); }
        if(*(lindex(temp,i)+1)=='/')
        {
         i++;
         if(*(lindex(temp,i))=='0') strcat(buf,"\000");
         if(*(lindex(temp,i))=='1') strcat(buf,"\001");
         if(*(lindex(temp,i))=='2') strcat(buf,"\002");
         if(*(lindex(temp,i))=='3') strcat(buf,"\003");
         if(*(lindex(temp,i))=='4') strcat(buf,"\004");
         if(*(lindex(temp,i))=='5') strcat(buf,"\005");
         if(*(lindex(temp,i))=='6') strcat(buf,"\006");
         if(*(lindex(temp,i))=='7') strcat(buf,"\007");
         if(*(lindex(temp,i))=='8') strcat(buf,"\008");
         if(*(lindex(temp,i))=='9') strcat(buf,"\009");
        }
        if(*(lindex(temp,i)+1)=='p') 
        { sprintf(temp4,"%d",pid); strcat(buf,temp4); }
        if(*(lindex(temp,i)+1)=='t')
        {
         lt=time(NULL);
         strcpy(temp4,ctime(&lt));
         temp4[strlen(temp4)-1]=' ';
         strcat(buf,temp4);
        }
        if(*(lindex(temp,i)+1)=='r')
        {
        }
        if(*(lindex(temp,i)+1)=='l') { strcat(buf,"\n"); }
        if(*(lindex(temp,i)+1)=='_') { strcat(buf," "); }
        if(*(lindex(temp,i)+1)=='3') { sleep(3); }
        if(*(lindex(temp,i)+1)=='%')              
        {
         sprintf(temp4,"%d",current_for);
         strcat(buf,temp4);
        }
        if(*(lindex(temp,i)+1)=='4') { sleep(4); }
        if(*(lindex(temp,i)+1)=='g')
        {
         strcpy(subnumber,lindex(temp,(i+1)));
         sline=0;
         while(script[sline]!=NULL)
         {
          sline++;
          strcpy(temp,script[sline]);
          if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
         }
         pain_in_the=1;
         goto_on = 1;
         break;
        }
        if(*(lindex(temp,i)+1)=='5') { sleep(5); }
        if(*(lindex(temp,i)+1)=='6') { sleep(6); }
        if(*(lindex(temp,i)+1)=='7') { sleep(7); }
        if(*(lindex(temp,i)+1)=='8') { sleep(8); }
        if(*(lindex(temp,i)+1)=='i')
        {    
         i++;
         fpa=fopen(lindex(temp,i),"r");
         strcpy(temp2,"");
         for(j=0;j!=atoi(lindex(temp,(i+1)));j++)
          fgets(temp2,255,fpa);
         strcat(buf,temp2);
         if(fpa!=NULL) fclose(fpa); 
         i++;
        }
        if(*(lindex(temp,i)+1)=='9') { sleep(9); }
        if(*(lindex(temp,i)+1)=='n')
        {
         strcat(buf,nick);
        }
        if(*(lindex(temp,i)+1)=='u')
        {
         strcat(buf,user);
        }
        if(*(lindex(temp,i)+1)=='e')
        {
         sprintf(temp4,"[%ld] Normal exit [pid=%d]\n",time(NULL),pid);
         appendlog(temp4);         
         shutdown(sockfd,2);
         close(sockfd);
         if(strcasecmp(cron,"")) system(cron);
         exit(0);
        }
        if(*(lindex(temp,i)+1)=='b')
        {
         goto_on = 1;
         loop = 0;
        }
        if(*(lindex(temp,i)+1)=='s')
        {
         i++;
         strcat(buf,lrange(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
         i++;
        }
       } 
       else
       {   
        strcat(buf,lindex(temp,i));
       }
       if(!reversechop) strcat(buf," ");
      }
      strcat(buf,"\n");
      if(goto_on) goto_on=0; else
      write(sockfd, buf, strlen(buf));
      if(debug) printf(">>> %s\n",buf);
     }
     if(pain_in_the) { pain_in_the=0; break; }
    }  
   if(fpa!=NULL) fclose(fpa);
   }
  }
  if(!strcasecmp(lindex(temp,0),"ifmaster2"))
  {
   if(!strcasecmp(lindex(temp,3),lindex2(in[atoi(lindex(temp,1))],atoi(lindex(temp,2)))))
   {   
    if(!strcasecmp(lindex(temp,5),lindex2(in[atoi(lindex(temp,1))],atoi(lindex(temp,4)))))
    {
     fpa=fopen(master,"r");
     while(fgets(temp2,255,fpa)!=NULL)
     {
      if(!match(lindex2(temp2,0),lindex(in[atoi(lindex(temp,1))],0)))
      {
       bzero(buf,1024);
       strcpy(buf,"");
       for(i=6;lindex(temp,i)!=NULL;i++)
       {
        if(reversechop) strcat(buf," ");
        if(*lindex(temp,i)=='$')
        {
         if(*(lindex(temp,i)+1)=='w')
         {
          i++;
          if(lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1)))!=NULL)
          strcat(buf,lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
          i++;
         }
         if(*(lindex(temp,i)+1)=='1') { sleep(1); }
         if(*(lindex(temp,i)+1)=='2') { sleep(2); }
         if(*(lindex(temp,i)+1)=='$') { strcat(buf,"$"); }
         if(*(lindex(temp,i)+1)=='\\') { strcat(buf,"\002"); }
         if(*(lindex(temp,i)+1)=='/')
         {
          i++;
          if(*(lindex(temp,i))=='0') strcat(buf,"\000");
          if(*(lindex(temp,i))=='1') strcat(buf,"\001");
          if(*(lindex(temp,i))=='2') strcat(buf,"\002");
          if(*(lindex(temp,i))=='3') strcat(buf,"\003");
          if(*(lindex(temp,i))=='4') strcat(buf,"\004");
          if(*(lindex(temp,i))=='5') strcat(buf,"\005");
          if(*(lindex(temp,i))=='6') strcat(buf,"\006");
          if(*(lindex(temp,i))=='7') strcat(buf,"\007");
          if(*(lindex(temp,i))=='8') strcat(buf,"\008");
          if(*(lindex(temp,i))=='9') strcat(buf,"\009");
         }
         if(*(lindex(temp,i)+1)=='p') 
         { sprintf(temp4,"%d",pid); strcat(buf,temp4); }
         if(*(lindex(temp,i)+1)=='t')
         {
          lt=time(NULL);
          strcpy(temp4,ctime(&lt));
          temp4[strlen(temp4)-1]=' ';
          strcat(buf,temp4);
         }
         if(*(lindex(temp,i)+1)=='r')
         {
         }
         if(*(lindex(temp,i)+1)=='l') { strcat(buf,"\n"); }
         if(*(lindex(temp,i)+1)=='_') { strcat(buf," "); }
         if(*(lindex(temp,i)+1)=='3') { sleep(3); }
         if(*(lindex(temp,i)+1)=='%')              
         {
          sprintf(temp4,"%d",current_for);
          strcat(buf,temp4);
         }
         if(*(lindex(temp,i)+1)=='4') { sleep(4); }
         if(*(lindex(temp,i)+1)=='5') { sleep(5); }
         if(*(lindex(temp,i)+1)=='g')
         {
          strcpy(subnumber,lindex(temp,(i+1)));
          sline=0;
          while(script[sline]!=NULL)
          {
           sline++;
           strcpy(temp,script[sline]);
           if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
          }
          pain_in_the=1;
          goto_on = 1;
          break;
         }
         if(*(lindex(temp,i)+1)=='6') { sleep(6); }
         if(*(lindex(temp,i)+1)=='i')
         {    
          i++;
          fpa=fopen(lindex(temp,i),"r");
          strcpy(temp2,"");
          for(j=0;j!=atoi(lindex(temp,(i+1)));j++)
           fgets(temp2,255,fpa);
          strcat(buf,temp2);
          if(fpa!=NULL) fclose(fpa); 
          i++;
         }
         if(*(lindex(temp,i)+1)=='7') { sleep(7); }
         if(*(lindex(temp,i)+1)=='8') { sleep(8); }
         if(*(lindex(temp,i)+1)=='9') { sleep(9); }
         if(*(lindex(temp,i)+1)=='e')
         {
          sprintf(temp4,"[%ld] Normal exit [pid=%d]\n",time(NULL),pid);
          appendlog(temp4);         
          shutdown(sockfd,2);
          close(sockfd);
          if(strcasecmp(cron,"")) system(cron);
          exit(0);
         }
         if(*(lindex(temp,i)+1)=='n')
         {
          strcat(buf,nick);
         }
         if(*(lindex(temp,i)+1)=='u')
         {
          strcat(buf,user);
         }
         if(*(lindex(temp,i)+1)=='b')
         {
          goto_on = 1;
          loop = 0;
         }
         if(*(lindex(temp,i)+1)=='s')
         {
          i++;
          strcat(buf,lrange(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
          i++;
         }
        } 
        else
        {   
         strcat(buf,lindex(temp,i));
        } 
        if(!reversechop) strcat(buf," ");
       }
       strcat(buf,"\n");
       if(goto_on) goto_on=0; else
       write(sockfd, buf, strlen(buf));
       if(debug) printf(">>> %s\n",buf);
      }
     if(pain_in_the) { pain_in_the=0; break; }
     }
    if(fpa!=NULL) fclose(fpa);
    }
   }
  }
  if(!strcasecmp(lindex(temp,0),"msgbox"))
  {
#ifdef GUI
#ifndef GTK
   XFlush(display[2]);
#endif
   msgbox("info",in[atoi(lindex(temp,1))],strlen(in[atoi(lindex(temp,1))]));
#else
   lasterror=105;
#endif
  }
  if(!strcasecmp(lindex(temp,0),"textbox"))
  {
#ifdef GUI
   textview(lindex(temp,1),argc,argv);
#else
   lasterror=105;
#endif
  }
  if(!strcasecmp(lindex(temp,0),"viewfile"))
  {
#ifdef GUI
   if(lindex(temp,2)==NULL || strcasecmp(lindex(temp,2),"-query"))
    viewfile(lindex(temp,1),argc,argv);
   else
   {
    view_n_query(lindex(temp,1),in[atoi(lindex(temp,3))],argc,argv);  
    strcpy(in[atoi(lindex(temp,3))],queryGlVar);
   }
#else
   lasterror=105;
#endif
  }
  if(!strcasecmp(lindex(temp,0),"query"))
  {
#ifdef GUI
   query(in[atoi(lindex(temp,1))],argc,argv);
   strcpy(in[atoi(lindex(temp,2))],queryGlVar);
#else
   lasterror=105;
#endif
  }
  if(!strcasecmp(lindex(temp,0),"print"))
  {
   bzero(buf,1024);
   strcpy(buf,"");
   for(i=1;lindex(temp,i)!=NULL;i++)
   {
    if(reversechop) strcat(buf," ");
    if(*lindex(temp,i)=='$')
    {
     if(*(lindex(temp,i)+1)=='w')
     {
      i++;
      if(lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1)))!=NULL)
      strcat(buf,lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
      i++;
     }
     if(*(lindex(temp,i)+1)=='n')
     {
      strcat(buf,nick);
     }
     if(*(lindex(temp,i)+1)=='1') { sleep(1); }
     if(*(lindex(temp,i)+1)=='$') { strcat(buf,"$"); }
     if(*(lindex(temp,i)+1)=='\\') { strcat(buf,"\002"); }
     if(*(lindex(temp,i)+1)=='/')
     {
      i++;
      if(*(lindex(temp,i))=='0') strcat(buf,"\000");
      if(*(lindex(temp,i))=='1') strcat(buf,"\001");
      if(*(lindex(temp,i))=='2') strcat(buf,"\002");
      if(*(lindex(temp,i))=='3') strcat(buf,"\003");
      if(*(lindex(temp,i))=='4') strcat(buf,"\004");
      if(*(lindex(temp,i))=='5') strcat(buf,"\005");
      if(*(lindex(temp,i))=='6') strcat(buf,"\006");
      if(*(lindex(temp,i))=='7') strcat(buf,"\007");
      if(*(lindex(temp,i))=='8') strcat(buf,"\008");
      if(*(lindex(temp,i))=='9') strcat(buf,"\009");
     }
     if(*(lindex(temp,i)+1)=='p') 
     { sprintf(temp4,"%d",pid); strcat(buf,temp4); }
     if(*(lindex(temp,i)+1)=='t')
     {
      lt=time(NULL);
      strcpy(temp4,ctime(&lt));
      temp4[strlen(temp4)-1]=' ';
      strcat(buf,temp4);
     }
     if(*(lindex(temp,i)+1)=='r')
     {
     }
     if(*(lindex(temp,i)+1)=='_') { strcat(buf," "); }
     if(*(lindex(temp,i)+1)=='l') { strcat(buf,"\n"); }
     if(*(lindex(temp,i)+1)=='%')              
     {
      sprintf(temp4,"%d",current_for);
      strcat(buf,temp4);
     }
     if(*(lindex(temp,i)+1)=='2') { sleep(2); }
     if(*(lindex(temp,i)+1)=='3') { sleep(3); }
     if(*(lindex(temp,i)+1)=='4') { sleep(4); }
     if(*(lindex(temp,i)+1)=='g')
     {
      strcpy(subnumber,lindex(temp,(i+1)));
      sline=0;
      while(script[sline]!=NULL)
      {
       sline++;
       strcpy(temp,script[sline]);
       if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
      }
      goto_on = 1;
      break;
     }
     if(*(lindex(temp,i)+1)=='5') { sleep(5); }
     if(*(lindex(temp,i)+1)=='6') { sleep(6); }
     if(*(lindex(temp,i)+1)=='i')
     {
      i++;
      fpa=fopen(lindex(temp,i),"r");
      strcpy(temp2,"");
      for(j=0;j!=atoi(lindex(temp,(i+1)));j++)
       fgets(temp2,255,fpa);
      strcat(buf,temp2);
      if(fpa!=NULL) fclose(fpa); 
      i++;
     }
     if(*(lindex(temp,i)+1)=='7') { sleep(7); }
     if(*(lindex(temp,i)+1)=='8') { sleep(8); }
     if(*(lindex(temp,i)+1)=='9') { sleep(9); }
     if(*(lindex(temp,i)+1)=='u')
     {
      strcat(buf,user);
     }
     if(*(lindex(temp,i)+1)=='e')
     {
      sprintf(temp4,"[%ld] Normal exit [pid=%d]\n",time(NULL),pid);
      appendlog(temp4);         
      shutdown(sockfd,2);
      close(sockfd);
      if(strcasecmp(cron,"")) system(cron);
      exit(0);
     }
     if(*(lindex(temp,i)+1)=='b')
     {
      goto_on = 1;
      loop = 0;
     }
     if(*(lindex(temp,i)+1)=='s')
     {
      i++;
      strcat(buf,lrange(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
      i++;
     }
    }   
    else
    {
     strcat(buf,lindex(temp,i));
    }
    if(!reversechop) strcat(buf," ");
   }
   printf("%s\n",buf);
  }
  if(!strcasecmp(lindex(temp,0),"setreversechop"))
  {
   reversechop = 1;
  }
  if(!strcasecmp(lindex(temp,0),"write"))
  {
   bzero(buf,1024);
   strcpy(buf,""); 
   if(sockfd<1) lasterror=111;
   for(i=1;lindex(temp,i)!=NULL;i++)
   {
    if(reversechop) strcat(buf," ");
    if(*lindex(temp,i)=='$')
    {
     if(*(lindex(temp,i)+1)=='w')
     {
      i++;
      if(lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1)))!=NULL)
      strcat(buf,lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
      i++;
     }
     if(*(lindex(temp,i)+1)=='n')
     {
      strcat(buf,nick);
     }
     if(*(lindex(temp,i)+1)=='1') { sleep(1); }
     if(*(lindex(temp,i)+1)=='$') { strcat(buf,"$"); }
     if(*(lindex(temp,i)+1)=='\\') { strcat(buf,"\002"); }
     if(*(lindex(temp,i)+1)=='/')
     {
      i++;
      if(*(lindex(temp,i))=='0') strcat(buf,"\000");
      if(*(lindex(temp,i))=='1') strcat(buf,"\001");
      if(*(lindex(temp,i))=='2') strcat(buf,"\002");
      if(*(lindex(temp,i))=='3') strcat(buf,"\003");
      if(*(lindex(temp,i))=='4') strcat(buf,"\004");
      if(*(lindex(temp,i))=='5') strcat(buf,"\005");
      if(*(lindex(temp,i))=='6') strcat(buf,"\006");
      if(*(lindex(temp,i))=='7') strcat(buf,"\007");
      if(*(lindex(temp,i))=='8') strcat(buf,"\008");
      if(*(lindex(temp,i))=='9') strcat(buf,"\009");
     }
     if(*(lindex(temp,i)+1)=='p') 
     { sprintf(temp4,"%d",pid); strcat(buf,temp4); }
     if(*(lindex(temp,i)+1)=='t')
     {
      lt=time(NULL);
      strcpy(temp4,ctime(&lt));
      temp4[strlen(temp4)-1]=' ';
      strcat(buf,temp4);
     }
     if(*(lindex(temp,i)+1)=='r')
     {
     }
     if(*(lindex(temp,i)+1)=='_') { strcat(buf," "); }
     if(*(lindex(temp,i)+1)=='l') { strcat(buf,"\n"); }
     if(*(lindex(temp,i)+1)=='%')              
     {
      sprintf(temp4,"%d",current_for);
      strcat(buf,temp4);
     }
     if(*(lindex(temp,i)+1)=='2') { sleep(2); }
     if(*(lindex(temp,i)+1)=='3') { sleep(3); }
     if(*(lindex(temp,i)+1)=='4') { sleep(4); }
     if(*(lindex(temp,i)+1)=='g')
     {
      strcpy(subnumber,lindex(temp,(i+1)));
      sline=0;
      while(script[sline]!=NULL)
      {
       sline++;
       strcpy(temp,script[sline]);
       if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
      }
      goto_on = 1;
      break;
     }
     if(*(lindex(temp,i)+1)=='5') { sleep(5); }
     if(*(lindex(temp,i)+1)=='6') { sleep(6); }
     if(*(lindex(temp,i)+1)=='i')
     {    
      i++;
      fpa=fopen(lindex(temp,i),"r");
      strcpy(temp2,"");
      for(j=0;j!=atoi(lindex(temp,(i+1)));j++)
       fgets(temp2,255,fpa);
      strcat(buf,temp2);
      if(fpa!=NULL) fclose(fpa); 
      i++;
     }
     if(*(lindex(temp,i)+1)=='7') { sleep(7); }
     if(*(lindex(temp,i)+1)=='8') { sleep(8); }
     if(*(lindex(temp,i)+1)=='9') { sleep(9); }
     if(*(lindex(temp,i)+1)=='u')
     {
      strcat(buf,user);
     }
     if(*(lindex(temp,i)+1)=='e')
     {
      sprintf(temp4,"[%ld] Normal exit [pid=%d]\n",time(NULL),pid);
      appendlog(temp4);         
      shutdown(sockfd,2);
      close(sockfd);
      if(strcasecmp(cron,"")) system(cron);
      exit(0);
     }
     if(*(lindex(temp,i)+1)=='b')
     {
      goto_on = 1;
      loop = 0;
     }
     if(*(lindex(temp,i)+1)=='s')
     {
      i++;
      strcat(buf,lrange(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
      i++;
     }
    }   
    else
    {
     strcat(buf,lindex(temp,i));
    }
    if(!reversechop) strcat(buf," ");
   }
   if(!strictwrite) 
   {
    if(windows) strcat(buf,"\r\n");
    else strcat(buf,"\n");
   }
   else buf[strlen(buf)-1]='\n';
   if(goto_on) goto_on=0; else
   write(sockfd, buf, strlen(buf));
   if(debug) printf(">>> [%s]\n",buf);
  }
  if(!strcasecmp(lindex(temp,0),"remoteip"))
  {
   strcpy(in[atoi(lindex(temp,1))],remote_ip);
  }
  if(!strcasecmp(lindex(temp,0),"?match"))
  {
   if(lindex(in[atoi(lindex(temp,1))],0)!=NULL && lindex2(in[atoi(lindex(temp,2))],0)!=NULL)
   if(!match(lindex(in[atoi(lindex(temp,1))],0),lindex2(in[atoi(lindex(temp,2))],0)))
   {
    strcpy(subnumber,lindex(temp,(3)));
    sline=0;
    while(script[sline]!=NULL)
    {
     sline++;
     strcpy(temp,script[sline]);
     if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
    }
   }
  }
  if(!strcasecmp(lindex(temp,0),"!match"))
  { 
   if(lindex(in[atoi(lindex(temp,1))],0)!=NULL && lindex2(in[atoi(lindex(temp,2))],0)!=NULL)
   if(match(lindex(in[atoi(lindex(temp,1))],0),lindex2(in[atoi(lindex(temp,2))],0)))
   {
    strcpy(subnumber,lindex(temp,(3)));
    sline=0;
    while(script[sline]!=NULL)
    {
     sline++;
     strcpy(temp,script[sline]);
     if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
    }
   }
  }
  if(!strcasecmp(lindex(temp,0),"?compare")) 
  {
   if(lindex(in[atoi(lindex(temp,1))],0)!=NULL && lindex2(in[atoi(lindex(temp,2))],0)!=NULL)
   if(!strcasecmp(lindex(in[atoi(lindex(temp,1))],0),lindex2(in[atoi(lindex(temp,2))],0)))
   {
    strcpy(subnumber,lindex(temp,(3)));
    sline=0;
    while(script[sline]!=NULL)
    {
     sline++;
     strcpy(temp,script[sline]);
     if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
    }
   }
  }
  if(!strcasecmp(lindex(temp,0),"!compare"))
  {
   if(lindex(in[atoi(lindex(temp,1))],0)!=NULL && lindex2(in[atoi(lindex(temp,2))],0)!=NULL)
   if(strcasecmp(lindex(in[atoi(lindex(temp,1))],0),lindex2(in[atoi(lindex(temp,2))],0)))
   {
    strcpy(subnumber,lindex(temp,(3)));
    sline=0;
    while(script[sline]!=NULL)
    {
     sline++;
     strcpy(temp,script[sline]);
     if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break;
    }
   }
  }
  if(!strcasecmp(lindex(temp,0),"if"))
  {
   if(!strcasecmp(lindex(temp,2),"="))
   if(atoi(in[atoi(lindex(temp,1))])==atoi(in[atoi(lindex(temp,3))]))
   {
    strcpy(subnumber,lindex(temp,(4)));
    sline=0;
    while(script[sline]!=NULL)
    {
     sline++;
     strcpy(temp,script[sline]);
     if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
    }
   }
   if(!strcasecmp(lindex(temp,2),"=="))
   if(atoi(in[atoi(lindex(temp,1))])==atoi(in[atoi(lindex(temp,3))]))
   {
    strcpy(subnumber,lindex(temp,(4)));
    sline=0;
    while(script[sline]!=NULL)
    {
     sline++;
     strcpy(temp,script[sline]);

     if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
    }
   }
   if(!strcasecmp(lindex(temp,2),">"))
   if(atoi(in[atoi(lindex(temp,1))])>atoi(in[atoi(lindex(temp,3))]))
   {
    strcpy(subnumber,lindex(temp,(4)));
    sline=0;
    while(script[sline]!=NULL)
    {
     sline++;
     strcpy(temp,script[sline]);
     if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
    }
   }
   if(!strcasecmp(lindex(temp,2),"<"))
   if(atoi(in[atoi(lindex(temp,1))])<atoi(in[atoi(lindex(temp,3))]))
   {
    strcpy(subnumber,lindex(temp,(4)));
    sline=0;
    while(script[sline]!=NULL)
    {
     sline++;
     strcpy(temp,script[sline]);
     if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
    }
   }
  }
  if(!strcasecmp(lindex(temp,0),"ifmatch"))
  {
   bzero(matching,1024);
   strcpy(matching,"");
   for(i=0;lindex(in[atoi(lindex(temp,1))],i)!=NULL;i++)
   {
    strcat(matching,lindex(in[atoi(lindex(temp,1))],i));
   }
   if(!match(lindex(temp,2),matching))
   {
    bzero(buf,1024);
    strcpy(buf,"");
    for(i=3;lindex(temp,i)!=NULL;i++)
    {
     if(reversechop) strcat(buf," ");
     if(*lindex(temp,i)=='$')
     {
      if(*(lindex(temp,i)+1)=='w')
      {
       i++;
       if(lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1)))!=NULL)
       strcat(buf,lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
       i++;
      }
      if(*(lindex(temp,i)+1)=='n')
      {
       strcat(buf,nick);
      }
      if(*(lindex(temp,i)+1)=='1') { sleep(1); }
      if(*(lindex(temp,i)+1)=='$') { strcat(buf,"$"); }
      if(*(lindex(temp,i)+1)=='\\') { strcat(buf,"\002"); }
      if(*(lindex(temp,i)+1)=='/')
      {
       i++;
       if(*(lindex(temp,i))=='0') strcat(buf,"\000");
       if(*(lindex(temp,i))=='1') strcat(buf,"\001");
       if(*(lindex(temp,i))=='2') strcat(buf,"\002");
       if(*(lindex(temp,i))=='3') strcat(buf,"\003");
       if(*(lindex(temp,i))=='4') strcat(buf,"\004");
       if(*(lindex(temp,i))=='5') strcat(buf,"\005");
       if(*(lindex(temp,i))=='6') strcat(buf,"\006");
       if(*(lindex(temp,i))=='7') strcat(buf,"\007");
       if(*(lindex(temp,i))=='8') strcat(buf,"\008");
       if(*(lindex(temp,i))=='9') strcat(buf,"\009");
      }
      if(*(lindex(temp,i)+1)=='p') 
      { sprintf(temp4,"%d",pid); strcat(buf,temp4); }
      if(*(lindex(temp,i)+1)=='t')
      {
       lt=time(NULL);
       strcpy(temp4,ctime(&lt));
       temp4[strlen(temp4)-1]=' ';
       strcat(buf,temp4);
      }
      if(*(lindex(temp,i)+1)=='r')
      {
      }
      if(*(lindex(temp,i)+1)=='_') { strcat(buf," "); }
      if(*(lindex(temp,i)+1)=='l') { strcat(buf,"\n"); }
      if(*(lindex(temp,i)+1)=='%')              
      {
       sprintf(temp4,"%d",current_for);
       strcat(buf,temp4);
      }
      if(*(lindex(temp,i)+1)=='g')
      {
       strcpy(subnumber,lindex(temp,(i+1)));
       sline=0;
       while(script[sline]!=NULL)
       {
        sline++;
        strcpy(temp,script[sline]);
        if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
       }
       goto_on = 1;
       break;
      }
      if(*(lindex(temp,i)+1)=='2') { sleep(2); }
      if(*(lindex(temp,i)+1)=='i')
      {    
       i++;
       fpa=fopen(lindex(temp,i),"r");
       strcpy(temp2,"");
       for(j=0;j!=atoi(lindex(temp,(i+1)));j++)
        fgets(temp2,255,fpa);
       strcat(buf,temp2);
       if(fpa!=NULL) fclose(fpa); 
       i++;
      }
      if(*(lindex(temp,i)+1)=='3') { sleep(3); }
      if(*(lindex(temp,i)+1)=='4') { sleep(4); }
      if(*(lindex(temp,i)+1)=='5') { sleep(5); }
      if(*(lindex(temp,i)+1)=='6') { sleep(6); }
      if(*(lindex(temp,i)+1)=='7') { sleep(7); }
      if(*(lindex(temp,i)+1)=='e')
      {
       sprintf(temp4,"[%ld] Normal exit [pid=%d]\n",time(NULL),pid);
       appendlog(temp4);         
       shutdown(sockfd,2);
       close(sockfd);
       if(strcasecmp(cron,"")) system(cron);
       exit(0);
      }
      if(*(lindex(temp,i)+1)=='8') { sleep(8); }
      if(*(lindex(temp,i)+1)=='9') { sleep(9); }
      if(*(lindex(temp,i)+1)=='u')
      {
       strcat(buf,user);
      }
      if(*(lindex(temp,i)+1)=='b')
      {
       goto_on = 1;
       loop = 0;
      }
      if(*(lindex(temp,i)+1)=='s')
      {
       i++;
       strcat(buf,lrange(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
       i++;
      }
     } 
     else
     { 
      strcat(buf,lindex(temp,i));
     }
     if(!reversechop) strcat(buf," ");
    }
    if(windows) strcat(buf,"\r\n");
    else strcat(buf,"\n");
    if(goto_on) goto_on=0; else
    write(sockfd, buf, strlen(buf));
    if(debug) printf(">>> %s\n",buf);
   }  
  }
  if(!strcasecmp(lindex(temp,0),"ifword")) 
  {
   if(!strcasecmp(lindex(temp,3),lindex2(in[atoi(lindex(temp,1))],atoi(lindex(temp,2)))))
   {
    bzero(buf,1024);
    strcpy(buf,"");
    for(i=4;lindex(temp,i)!=NULL;i++)
    {
     if(reversechop) strcat(buf," ");
     if(*lindex(temp,i)=='$')
     {
      if(*(lindex(temp,i)+1)=='w')
      {
       i++;
       if(lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1)))!=NULL)
       strcat(buf,lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
       i++;
      }
      if(*(lindex(temp,i)+1)=='n')
      {
       strcat(buf,nick);
      }
      if(*(lindex(temp,i)+1)=='1') { sleep(1); }
      if(*(lindex(temp,i)+1)=='$') { strcat(buf,"$"); }
      if(*(lindex(temp,i)+1)=='\\') { strcat(buf,"\002"); }
      if(*(lindex(temp,i)+1)=='/')
      {
       i++;
       if(*(lindex(temp,i))=='0') strcat(buf,"\000");
       if(*(lindex(temp,i))=='1') strcat(buf,"\001");
       if(*(lindex(temp,i))=='2') strcat(buf,"\002");
       if(*(lindex(temp,i))=='3') strcat(buf,"\003");
       if(*(lindex(temp,i))=='4') strcat(buf,"\004");
       if(*(lindex(temp,i))=='5') strcat(buf,"\005");
       if(*(lindex(temp,i))=='6') strcat(buf,"\006");
       if(*(lindex(temp,i))=='7') strcat(buf,"\007");
       if(*(lindex(temp,i))=='8') strcat(buf,"\008");
       if(*(lindex(temp,i))=='9') strcat(buf,"\009");
      }
      if(*(lindex(temp,i)+1)=='p') 
      { sprintf(temp4,"%d",pid); strcat(buf,temp4); }
      if(*(lindex(temp,i)+1)=='t')
      {
       lt=time(NULL);
       strcpy(temp4,ctime(&lt));
       temp4[strlen(temp4)-1]=' ';
       strcat(buf,temp4);
      }
      if(*(lindex(temp,i)+1)=='r')
      {
      }
      if(*(lindex(temp,i)+1)=='_') { strcat(buf," "); }
      if(*(lindex(temp,i)+1)=='l') { strcat(buf,"\n"); }
      if(*(lindex(temp,i)+1)=='%')              
      {
       sprintf(temp4,"%d",current_for);
       strcat(buf,temp4);
      }
      if(*(lindex(temp,i)+1)=='g')
      {
       strcpy(subnumber,lindex(temp,(i+1)));
       sline=0;
       while(script[sline]!=NULL)
       {
        sline++;
        strcpy(temp,script[sline]);
        if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
       }
       goto_on = 1;
       break;
      }
      if(*(lindex(temp,i)+1)=='i')
      {    
       i++;
       fpa=fopen(lindex(temp,i),"r");
       strcpy(temp2,"");
       for(j=0;j!=atoi(lindex(temp,(i+1)));j++)
        fgets(temp2,255,fpa);
       strcat(buf,temp2);
       if(fpa!=NULL) fclose(fpa); 
       i++;
      }
      if(*(lindex(temp,i)+1)=='2') { sleep(2); }
      if(*(lindex(temp,i)+1)=='3') { sleep(3); }
      if(*(lindex(temp,i)+1)=='4') { sleep(4); }
      if(*(lindex(temp,i)+1)=='e')
      {
       sprintf(temp4,"[%ld] Normal exit [pid=%d]\n",time(NULL),pid);
       appendlog(temp4);
       shutdown(sockfd,2);
       close(sockfd);
       if(strcasecmp(cron,"")) system(cron);
       exit(0);
      }
      if(*(lindex(temp,i)+1)=='5') { sleep(5); }
      if(*(lindex(temp,i)+1)=='6') { sleep(6); }
      if(*(lindex(temp,i)+1)=='7') { sleep(7); }
      if(*(lindex(temp,i)+1)=='8') { sleep(8); }
      if(*(lindex(temp,i)+1)=='9') { sleep(9); }
      if(*(lindex(temp,i)+1)=='u')
      {
       strcat(buf,user);
      }
      if(*(lindex(temp,i)+1)=='b')
      {
       goto_on = 1;
       loop = 0;
      }
      if(*(lindex(temp,i)+1)=='s')
      {
       i++;
       strcat(buf,lrange(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
       i++;
      }
     }
     else
     {
      strcat(buf,lindex(temp,i));
     }
     if(!reversechop) strcat(buf," ");
    }
    if(windows) strcat(buf,"\r\n");
    else strcat(buf,"\n");
    if(goto_on) goto_on=0; else
    write(sockfd, buf, strlen(buf));
    if(debug) printf(">>> %s\n",buf);
   }
  }
  if(!strcasecmp(lindex(temp,0),"ifword2"))
  {
   if(!strcasecmp(lindex(temp,3),lindex2(in[atoi(lindex(temp,1))],atoi(lindex(temp,2)))))
   {
    if(!strcasecmp(lindex(temp,5),lindex2(in[atoi(lindex(temp,1))],atoi(lindex(temp,4)))))
    {
     bzero(buf,1024);
     strcpy(buf,"");
     for(i=6;lindex(temp,i)!=NULL;i++)
     {
      if(reversechop) strcat(buf," ");
      if(*lindex(temp,i)=='$')
      {
       if(*(lindex(temp,i)+1)=='w')
       {
        i++;
        if(lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1)))!=NULL)
        strcat(buf,lindex(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
        i++;
       }
       if(*(lindex(temp,i)+1)=='n')
       {
        strcat(buf,nick);
       }
       if(*(lindex(temp,i)+1)=='u')
       {
        strcat(buf,user);
       }
       if(*(lindex(temp,i)+1)=='1') { sleep(1); }
       if(*(lindex(temp,i)+1)=='$') { strcat(buf,"$"); }
       if(*(lindex(temp,i)+1)=='\\') { strcat(buf,"\002"); }
       if(*(lindex(temp,i)+1)=='/')
       {
        i++;
        if(*(lindex(temp,i))=='0') strcat(buf,"\000");
        if(*(lindex(temp,i))=='1') strcat(buf,"\001");
        if(*(lindex(temp,i))=='2') strcat(buf,"\002");
        if(*(lindex(temp,i))=='3') strcat(buf,"\003");
        if(*(lindex(temp,i))=='4') strcat(buf,"\004");
        if(*(lindex(temp,i))=='5') strcat(buf,"\005");
        if(*(lindex(temp,i))=='6') strcat(buf,"\006");
        if(*(lindex(temp,i))=='7') strcat(buf,"\007");
        if(*(lindex(temp,i))=='8') strcat(buf,"\008");
        if(*(lindex(temp,i))=='9') strcat(buf,"\009");
       }
       if(*(lindex(temp,i)+1)=='p') 
       { sprintf(temp4,"%d",pid); strcat(buf,temp4); }
       if(*(lindex(temp,i)+1)=='t')
       {
        lt=time(NULL);
        strcpy(temp4,ctime(&lt));
        temp4[strlen(temp4)-1]=' ';
        strcat(buf,temp4);
       }
       if(*(lindex(temp,i)+1)=='r')
       {
       }
       if(*(lindex(temp,i)+1)=='_') { strcat(buf," "); }
       if(*(lindex(temp,i)+1)=='l') { strcat(buf,"\n"); }
       if(*(lindex(temp,i)+1)=='%')              
       {
        sprintf(temp4,"%d",current_for);
        strcat(buf,temp4);
       }
       if(*(lindex(temp,i)+1)=='g')
       {
        strcpy(subnumber,lindex(temp,(i+1)));
        sline=0;
        while(script[sline]!=NULL)
        {
         sline++;
         strcpy(temp,script[sline]);
         if(!strcasecmp(lindex(temp,0),"sub") && !strcasecmp(lindex(temp,1),subnumber)) break; 
        }
        goto_on = 1;
        break;
       }
       if(*(lindex(temp,i)+1)=='2') { sleep(2); }
       if(*(lindex(temp,i)+1)=='3') { sleep(3); }
       if(*(lindex(temp,i)+1)=='i')
       {    
        i++;
        fpa=fopen(lindex(temp,i),"r");
        strcpy(temp2,"");
        for(j=0;j!=atoi(lindex(temp,(i+1)));j++)
         fgets(temp2,255,fpa);
        strcat(buf,temp2);
        if(fpa!=NULL) fclose(fpa); 
        i++;
       }
       if(*(lindex(temp,i)+1)=='4') { sleep(4); }
       if(*(lindex(temp,i)+1)=='5') { sleep(5); }
       if(*(lindex(temp,i)+1)=='6') { sleep(6); }
       if(*(lindex(temp,i)+1)=='7') { sleep(7); }
       if(*(lindex(temp,i)+1)=='e')
       {
        sprintf(temp4,"[%ld] Normal exit [pid=%d]\n",time(NULL),pid);
        appendlog(temp4);         
        shutdown(sockfd,2);
        close(sockfd);
        if(strcasecmp(cron,"")) system(cron);
        exit(0);
       }
       if(*(lindex(temp,i)+1)=='8') { sleep(8); }
       if(*(lindex(temp,i)+1)=='9') { sleep(9); }
       if(*(lindex(temp,i)+1)=='b')
       {
        goto_on = 1;
        loop = 0;
       }
       if(*(lindex(temp,i)+1)=='s')
       {
        i++;
        strcat(buf,lrange(in[atoi(lindex2(temp,i))],atoi(lindex(temp,i+1))));
        i++;
       }
      }
      else
      {
       strcat(buf,lindex(temp,i)); 
      } 
      if(!reversechop) strcat(buf," ");
     }
     if(windows) strcat(buf,"\r\n");
     else strcat(buf,"\n");
     if(goto_on) goto_on=0; else
     write(sockfd, buf, strlen(buf));
     if(debug) printf(">>> %s\n",buf);
    }
   }   
  }
 }
 close(sockfd);
 if(strcasecmp(cron,"")) system(cron);
}

char *lindex2(char *input_string, int word_number)
{
 char *tokens[255];
 static char tmpstring[512];
 int i;
 strcpy(tmpstring,input_string);
 tokens[i=0] = (char *)strtok(tmpstring, " ");
 while ((tokens[++i] = (char *)strtok(NULL, " ")));
 tokens[i] = NULL;
 return (char *)tokens[word_number];
}

char *lrange(char *input_string, int starting_at)
{
 char *tokens[1024];
 static char tmpstring[1024]="";
 int i;
 char out_string[1024]="";
 strcpy(out_string,"");
 if(input_string==NULL) {
  strcpy(out_string," ");
  strcat(out_string,NULL);
  strcpy(global_var,out_string);
  return (char *)global_var; }
 strcpy(tmpstring,input_string);
 tokens[i=0] = strtok(tmpstring, " ");
 while((tokens[++i] = strtok(NULL, " ")));
 tokens[i] = NULL;
 i++;
 if(i<starting_at)
 {
  lasterror=113;
  return (char *)"";
 }
 while(tokens[starting_at] != NULL)
 {
  strcat(out_string,tokens[starting_at]);
  strcat(out_string, " ");
  starting_at++;
 }
 strcpy(global_var,out_string);
 return (char *)global_var;
}

int match(char *check,char *orig)
{ 
 while(*check == '*' || tolower(*check)==tolower(*orig) || *check == '?') 
  if(*check == '*')
  if(*++check)
  {
   while(*orig)
    if(!match(check,orig++)) return 0;
   return 1;
  }
  else return 0;
  else if (!*check) return 0;
  else if (!*orig) return 1;
  else 
  {
   ++check;
   ++orig;
  }
 return 1;
}

appendlog(char *what)
{
 FILE *fdlog;
 if(strcasecmp(lindex(logfilename,0),"syslog"))
 {
  fdlog=fopen(lindex(logfilename,0),"a");
  if(fdlog==NULL || fileno(fdlog)<0) { lasterror=114; return; }
  fputs(what,fdlog);
  if(fdlog!=NULL) fclose(fdlog);
 }
 else
 {
  openlog("SScript",LOG_PID,LOG_USER);
  syslog(LOG_INFO|LOG_USER,"%s",what);
  closelog();
 }
}

udp_send(char in[1024][1024])
{
 int udpsock,i;
 struct sockaddr_in udpaddr;
 char msg[255];
 strcpy(msg,lrange(in[atoi(lindex(temp,1))],2));
 udpsock = socket(AF_INET, SOCK_DGRAM, 0);
 if(udpsock<0)
 {
  sprintf(in[atoi(lindex(temp,1))],"SOCKET FAILED: %s",strerror(errno));
  lasterror=109;
  return -1;
 }
 udpaddr.sin_family = AF_INET;
 udpaddr.sin_port = htons(atoi(lindex(in[atoi(lindex2(temp,1))],1)));
 udpaddr.sin_addr.s_addr = inet_addr(lindex(in[atoi(lindex2(temp,1))],0));
 if(sendto(udpsock,msg,sizeof(msg),0,(struct sockaddr *)&udpaddr,sizeof(udpaddr))<0)
 {
  sprintf(in[atoi(lindex(temp,1))],"SEND FAILED: %s",strerror(errno));
  lasterror=110;
  return -1;
 }
}

udp_listen(char in[1024][1024])
{
 int udpsock,len;
 struct sockaddr_in udpaddr, from;
 char msg[255];
 udpsock = socket(AF_INET, SOCK_DGRAM, 0);
 if(udpsock<0)
 {
  sprintf(in[atoi(lindex(temp,1))],"SOCKET FAILED: %s",strerror(errno));
  lasterror=109;
  return -1;
 }
 udpaddr.sin_family = AF_INET;
 udpaddr.sin_addr.s_addr = INADDR_ANY;
 udpaddr.sin_port = htons(atoi(lindex(temp,2)));
 if(bind(udpsock,(struct sockaddr *)&udpaddr,sizeof(udpaddr))<0)
 {
  sprintf(in[atoi(lindex(temp,1))],"BIND FAILED: %s",strerror(errno));
  lasterror=115;
  return -1;
 }
 len = sizeof(from);
 if(recvfrom(udpsock,msg,sizeof(msg),0,(struct sockaddr *)&from,&len)<0)
 {
  sprintf(in[atoi(lindex(temp,1))],"RECEIVE FAILED: %s",strerror(errno));
  lasterror=116;
  return -1;
 }
 strcpy(in[atoi(lindex(temp,1))],msg);
 close(udpsock);
}

addtrace(int type)
{
 FILE *fptrace;
 char my[16];
 fptrace=fopen("trace.log","a");
 if(fptrace==NULL || fileno(fptrace)<0) { lasterror=103; return; }
 if(type==-1) fputs(temp,fptrace);
 else
 {
  sprintf(my,"lasterror: %d",lasterror);
  fputs(my,fptrace);
 }
 fputs("\n",fptrace);
 if(fptrace!=NULL) fclose(fptrace);
}

icmp_detect(char in[1024][1024])
{
 /* Should be a better function than this, but this'll have to do for
    now since icmpinfo seg faults if I try to add it. */
 char readbuf[4096];
 int icmpsock,from,result,type,len;
 struct sockaddr_in icmpaddr;
 strcpy(in[atoi(lindex(temp,1))],"");
 if((icmpsock=socket(AF_INET, SOCK_RAW, IPPROTO_ICMP))<0)
 {
  sprintf(in[atoi(lindex(temp,1))],"SOCKET FAILED: %s",strerror(errno));
  lasterror=109;
  return -1;
 }
 icmpaddr.sin_family = AF_INET;
 icmpaddr.sin_addr.s_addr = INADDR_ANY;
 icmpaddr.sin_port = 0;
 if(bind(icmpsock,(struct sockaddr *)&icmpaddr,sizeof(icmpaddr))<0)
 {
  sprintf(in[atoi(lindex(temp,1))],"BIND FAILED: %s",strerror(errno));
  lasterror=115;
  return -1;
 }
 len=sizeof(icmpaddr);
 if(getsockname(icmpsock,(struct sockaddr *)&icmpaddr,&len)<0)
 {
  sprintf(in[atoi(lindex(temp,1))],"SOCKET ADDRESS: %s",strerror(errno));
  lasterror=117;
  return -1;
 }
 if((result=read(icmpsock,readbuf,sizeof(readbuf)))<0)
 {
  sprintf(in[atoi(lindex(temp,1))],"READING FAILED: %s",strerror(errno));
  lasterror=118;
  return -1;
 }
 type=readbuf[20] & 0xff;
 sprintf(in[atoi(lindex(temp,1))],"%ld %d %d.%d.%d.%d ;",time(NULL),type,readbuf[12]&0xff,readbuf[13]&0xff,readbuf[14]&0xff,readbuf[15]&0xff);
}

resolve(char in[1024][1024])
{
 struct hostent *hp;
 struct sockaddr_in from;
 unsigned long dest;
 if(!strcasecmp(lindex(temp,1),"host"))
 {
  memset(&from, 0, sizeof(struct sockaddr_in));
  from.sin_family = AF_INET;
  hp=gethostbyname(lindex(in[atoi(lindex2(temp,2))],0));
  if(hp==NULL) strcpy(in[atoi(lindex(temp,3))],"unknown");
  else
  {
   memcpy(&from.sin_addr,hp->h_addr,hp->h_length);
   strcpy(in[atoi(lindex(temp,3))],inet_ntoa(from.sin_addr));
  }
 }
 else if(!strcasecmp(lindex(temp,1),"ip"))
 {
  from.sin_family = AF_INET;
  from.sin_addr.s_addr = inet_addr(lindex(in[atoi(lindex2(temp,2))],0));
  hp=gethostbyaddr((char *)&from.sin_addr, sizeof(struct in_addr),from.sin_family);
  if(hp==NULL) strcpy(in[atoi(lindex(temp,3))],"unknown");
  else strcpy(in[atoi(lindex(temp,3))],(char *)hp->h_name);;
 }
 else
 {
  strcpy(in[atoi(lindex(temp,3))],"Unknown request type.");
 }
}

#ifdef GUI
#ifndef GTK
void closebox() {
 XtDestroyWidget(msgwidget);
 displayed=0;
}

int msgbox(char *type, char *textstring, int len)
{/* based on xmsg by Willy Tarreau, under GPL */
 Arg args[20];
 char blah[255];
 register int nargs, nwidgets;  
 int width;
 XtCallbackRec button1[2];
 if (displayed) return;
 displayed=1;
 if(lang==0)
 {
  if(!strcasecmp(type,"header")) strcpy(blah,"Starting...");
  else if(!strcasecmp(type,"info")) strcpy(blah,"Information:");
  else if(!strcasecmp(type,"error")) strcpy(blah,"ERROR:");
 }
 else if(lang==1)
 {
  if(!strcasecmp(type,"header")) strcpy(blah,"Demarrer...");
  else if(!strcasecmp(type,"info")) strcpy(blah,"Information:");
  else if(!strcasecmp(type,"error")) strcpy(blah,"ERREUR:");
 }
 else if(lang==2)
 {   
  if(!strcasecmp(type,"header")) strcpy(blah,"Iniciando...");
  else if(!strcasecmp(type,"info")) strcpy(blah,"Informacion:");
  else if(!strcasecmp(type,"error")) strcpy(blah,"ERROR:");
 }
 bzero(button1, sizeof(button1));
 button1[0].callback = closebox;
 button1[0].closure = (caddr_t) 0;
 nargs = 0;
 SetArg(XtNx, 10);
 SetArg(XtNy, 10);
 SetArg(XtNtitle, "Socket Script");
 SetArg(XtNmaxHeight, 130);
 SetArg(XtNminHeight, 120);
 SetArg(XtNmaxWidth, (len+25)*8);
 SetArg(XtNminWidth, (len+20)*8);
 msgwidget=XtCreateWidget("window", applicationShellWidgetClass, toplevel, args, nargs);
 nargs = 0;
 form = XtCreateWidget("box", boxWidgetClass, msgwidget, args, nargs);
 XtManageChild(form);
 nargs = 0;
 SetArg(XtNlabel,blah);
 SetArg("borderWidth", 0);
 SetArg(XtNjustify,XtJustifyCenter);
 SetArg(XtNwidth,(len+20)*8);
 SetArg(XtNheight,15);
 XtManageChild(last=XtCreateWidget("label", labelWidgetClass, form, args, nargs));
 nargs = 0;
 SetArg(XtNlabel, textstring);
 SetArg(XtNborderWidth, 1);
 SetArg(XtNjustify,XtJustifyCenter);
 SetArg(XtNfromVert,last);   
 SetArg(XtNwidth,(len+20)*8);
 SetArg(XtNheight,60);
 XtManageChild(textbox=XtCreateWidget("textbox", labelWidgetClass, form, args, nargs));
 nwidgets = 0;
 nargs = 0;
 SetArg(XtNcallback, button1);
 SetArg(XtNfromVert, textbox);
 SetArg(XtNhighlightThickness, -1);
 SetArg(XtNwidth, (len+20)*8);
 widgets[nwidgets++] = XtCreateWidget("OK", commandWidgetClass, form, args, nargs);
 XtManageChild(form);
 XtManageChildren(widgets, nwidgets);
 XtRealizeWidget(msgwidget);
 XtPopup(msgwidget, XtGrabExclusive);
 while(displayed) {
  XtAppNextEvent(ac2, &event);   
  XtDispatchEvent(&event);
 }
 XFlush(display[2]);
}

int queryOk(Widget result, XtPointer p1, XtPointer p2)
{
 strcpy(queryGlVar,XawDialogGetValueString(dialog1));
 XtDestroyWidget(mainbox);
 XtUnrealizeWidget(top);
 displayed = 0;
}

int queryOk2(Widget result, XtPointer p1, XtPointer p2) 
{
 strcpy(queryGlVar,XawDialogGetValueString(dialog1));
 XtDestroyWidget(mainbox);
 XtUnrealizeWidget(top4);
 displayed = 0;
}

int ContinueIt(Widget result, XtPointer p1, XtPointer p2)
{
 XtDestroyWidget(mainbox);
 XtUnrealizeWidget(top3);
 displayed = 0;
}

int queryQuit(Widget result, XtPointer p1, XtPointer p2)
{
 XtDestroyWidget(mainbox);
 exit(0);
}

int query(char *string, int argc1, char *argv1[])
{
 if(displayed) return 0;
 displayed = 1;
 mainbox = XtVaCreateManagedWidget("mainbox", boxWidgetClass, top, XtNmaxWidth, (strlen(string)+25)*8, XtNminWidth, (strlen(string)+20)*8, XtNx, 10, XtNy, 10, XtNmaxHeight, 130, XtNminHeight, 120, NULL);
 dialog1 = XtVaCreateManagedWidget("dialog1", dialogWidgetClass, mainbox, XtNlabel, string, XtNvalue, "", XtNwidth, (strlen(string)+20)*8, NULL);
 okbutton = XtVaCreateManagedWidget("OK", commandWidgetClass, dialog1, NULL);
 if(lang==0)
 quitbutton = XtVaCreateManagedWidget("Quit", commandWidgetClass, dialog1, NULL);
 else if(lang==1)
 quitbutton = XtVaCreateManagedWidget("Quitter", commandWidgetClass, dialog1, NULL);
 else if(lang==2)
 quitbutton = XtVaCreateManagedWidget("Salida", commandWidgetClass, dialog1, NULL);
 XtAddCallback(okbutton, XtNcallback, (XtPointer)queryOk, NULL);
 XtAddCallback(quitbutton, XtNcallback, (XtPointer)queryQuit, NULL);
 XtRealizeWidget(top);
 while(displayed) {
  XtAppNextEvent(ac, &qevent);
  XtDispatchEvent(&qevent); 
 }
 XFlush(display[1]);
}

int TextDone(Widget result, XtPointer p1, XtPointer p2)
{
 XawAsciiSaveAsFile(XawTextGetSource(viewbox), GlFile);
 XtDestroyWidget(mainbox);
 XtUnrealizeWidget(top6);
 displayed = 0;
}

int textview(char *file, int argc1, char *argv1[])
{
 if(displayed) return 0;
 displayed = 1;
 strcpy(GlFile,file);
 mainbox = XtVaCreateManagedWidget("mainbox", boxWidgetClass, top6, NULL);
 continuebutton = XtVaCreateManagedWidget("Done", commandWidgetClass, mainbox, NULL);
 viewbox = XtVaCreateManagedWidget("viewbox", asciiTextWidgetClass, mainbox, XtNheight, 300, XtNwidth, 600, XtNscrollVertical, XawtextScrollAlways, XtNscrollHorizontal, XawtextScrollAlways, XtNeditType, XawtextEdit, NULL);  
 XtAddCallback(continuebutton, XtNcallback, (XtPointer)TextDone, NULL);
 XtRealizeWidget(top6);
 while(displayed)
 {
  XtAppNextEvent(ac6, &qevent);
  XtDispatchEvent(&qevent);
 }
 XFlush(display[6]);
}

int viewfile(char *file, int argc1, char *argv1[])
{
 FILE *fd;
 char *file_buf;
 off_t len;
 struct stat stat_buf;
 if(displayed) return 0;
 displayed = 1;
 mainbox = XtVaCreateManagedWidget("mainbox", boxWidgetClass, top3, NULL);
 continuebutton = XtVaCreateManagedWidget("Continue",commandWidgetClass,mainbox,NULL);
 viewbox = XtVaCreateManagedWidget("viewbox", asciiTextWidgetClass, mainbox, XtNheight, 300, XtNwidth, 600, XtNscrollVertical, XawtextScrollWhenNeeded, XtNscrollHorizontal, XawtextScrollWhenNeeded, NULL);
 XtAddCallback(continuebutton, XtNcallback, (XtPointer)ContinueIt, NULL);
 if((fd=fopen(file,"ro"))==NULL)
 {
  if(lang==0)
  XtVaSetValues(viewbox, XtNstring, "\nCan't open that file\n\n", NULL);
  else if(lang==1)
  XtVaSetValues(viewbox, XtNstring, "\nNe peut ouvrir ce fichier\n\n", NULL);
  else if(lang==2)
  XtVaSetValues(viewbox, XtNstring, "\nNo se puede abrir el archivo\n\n", NULL);
 }
 else
 {
  fstat(fileno(fd), &stat_buf);
  len = stat_buf.st_size;
  file_buf = malloc(len * sizeof(char) +1);
  fread(file_buf, 1, len, fd);
  file_buf[len] = '\0';
  XtVaSetValues(viewbox, XtNstring, file_buf, NULL);
  free(file_buf);
  fclose(fd);
 }
 XtRealizeWidget(top3);
 while(displayed) {
  XtAppNextEvent(ac3, &qevent);
  XtDispatchEvent(&qevent);
 }
 XFlush(display[3]);
}

int view_n_query(char *file, char *string, int argc1, char *argv1[])
{
 FILE *fd;
 char *file_buf;
 off_t len;
 struct stat stat_buf;
 if(displayed) return 0;
 displayed = 1;
 mainbox = XtVaCreateManagedWidget("mainbox", boxWidgetClass, top4, NULL);
 dialog1 = XtVaCreateManagedWidget("dialog1", dialogWidgetClass, mainbox, XtNlabel, string, XtNvalue, "", NULL);
 continuebutton = XtVaCreateManagedWidget("Continue",commandWidgetClass,mainbox,NULL);
 viewbox = XtVaCreateManagedWidget("viewbox", asciiTextWidgetClass, mainbox, XtNheight, 300, XtNwidth, 500, XtNscrollVertical, XawtextScrollWhenNeeded, XtNscrollHorizontal, XawtextScrollWhenNeeded, NULL);
 XtAddCallback(continuebutton, XtNcallback, (XtPointer)queryOk2, NULL);
 if((fd=fopen(file,"ro"))==NULL)
  XtVaSetValues(viewbox, XtNstring, "\nCan't open that file\n\n", NULL);
 else
 {
  fstat(fileno(fd), &stat_buf);
  len = stat_buf.st_size;
  file_buf = malloc(len * sizeof(char) +1);
  fread(file_buf, 1, len, fd);
  file_buf[len] = '\0';
  XtVaSetValues(viewbox, XtNstring, file_buf, NULL);
  free(file_buf);
  fclose(fd);
 }
 XtRealizeWidget(top4);
 while(displayed) {
  XtAppNextEvent(ac4, &qevent);
  XtDispatchEvent(&qevent);
 }
 XFlush(display[4]);
}
#endif /* gtk */
#endif /* gui */

char *if_setup(char *device)
{
 /* based on Trevor F. Linton's code, with written consent */
 int sockfd, device_flags=0, found=0;
 char lbuf[255], *blen, *blenmax;
 struct ifreq ifreq, *ifr;
 struct ifconf ifc;
 if((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
 {
  sprintf(global_var, "SOCKET FAILED: %s", strerror(errno));
  lasterror=109;
  return (char *)global_var;
 }
 ifc.ifc_len = sizeof(lbuf);
 ifc.ifc_buf = lbuf;
 if(ioctl(sockfd, SIOCGIFCONF, (char *)&ifc) < 0)
 {
  sprintf(global_var, "IOCTL FAILED: %s", strerror(errno));
  lasterror=119;
  return (char *)global_var;
 }
 ifr = ifc.ifc_req;
 blenmax = lbuf + ifc.ifc_len;
 for(blen = lbuf; blen < blenmax; blen = blen + sizeof(ifr->ifr_name) + sizeof(ifr->ifr_addr))
 {
  ifr = (struct ifreq *)blen;
  if(strcmp(ifr->ifr_name, device)) continue;
  found = 1;
  ifreq = *ifr;
  if(ioctl(sockfd, SIOCGIFFLAGS, (char *)&ifreq) < 0)
  {
   sprintf(global_var, "IOCTL FAILED: %s", strerror(errno));
   lasterror=119;
   return (char *)global_var;
  }
  device_flags = ifreq.ifr_flags;
  sprintf(global_var, "%s ", ifreq.ifr_name);
  if((device_flags & IFF_PROMISC) != 0) strcat(global_var, "1 ");
  else strcat(global_var, "0 ");
  if((device_flags & IFF_UP) != 0) strcat(global_var, "1 ");
  else strcat(global_var, "0 ");
  if((device_flags & IFF_POINTOPOINT) != 0) strcat(global_var, "1 ");
  else strcat(global_var, "0 ");
  if((device_flags & IFF_BROADCAST) != 0) strcat(global_var, "1 ");
  else strcat(global_var, "0 ");
  if((device_flags & IFF_MULTICAST) != 0) strcat(global_var, "1 ");
  else strcat(global_var, "0 ");
  if((device_flags & IFF_ALLMULTI) != 0) strcat(global_var, "1 ");
  else strcat(global_var, "0 ");
  if((device_flags & IFF_NOARP) != 0) strcat(global_var, "1");
  else strcat(global_var, "0");
 }
 if(found==0) sprintf(global_var, "%s: Unknown device.", device);
 return (char *)global_var;
}

#ifdef GUI
#ifndef GTK
int choiceHdl(Widget result, XtPointer p1, XtPointer p2) 
{
 if(result==choicebutton[0]) strcpy(queryGlVar,"1");
 else if(result==choicebutton[1]) strcpy(queryGlVar,"2");
 else if(result==choicebutton[2]) strcpy(queryGlVar,"3");
 else if(result==choicebutton[3]) strcpy(queryGlVar,"4");
 else if(result==choicebutton[4]) strcpy(queryGlVar,"5");
 else if(result==choicebutton[5]) strcpy(queryGlVar,"6");
 else if(result==choicebutton[6]) strcpy(queryGlVar,"7");
 else if(result==choicebutton[7]) strcpy(queryGlVar,"8");
 else if(result==choicebutton[8]) strcpy(queryGlVar,"9");
 else if(result==choicebutton[9]) strcpy(queryGlVar,"10");
 else strcpy(queryGlVar,"-1");
 XtDestroyWidget(mainbox);
 XtUnrealizeWidget(top5);
 displayed = 0;
}

int choicebox(int argc1, char *argv1[])
{
 int i;
 if(displayed) return 0;
 displayed = 1;
 mainbox = XtVaCreateManagedWidget("mainbox", boxWidgetClass, top5, NULL);
 for(i=0;lindex(temp,i)!=NULL;i++)
 {
  if(!strcasecmp(lindex(temp,i),"|"))
  {
   last = XtVaCreateManagedWidget("label", labelWidgetClass, mainbox, XtNlabel, lrange(temp,i+1), "borderWidth", 0, NULL);
   break;
  }
 }
 i=0;
 if(lindex(temp,i+2)!=NULL && *lindex(temp,i+2)!='|')
 {
 choicebutton[i] = XtVaCreateManagedWidget(lindex(temp,i+2), commandWidgetClass, mainbox, NULL);
 XtAddCallback(choicebutton[i], XtNcallback, (XtPointer)choiceHdl, NULL);
 i++;
 }
 if(lindex(temp,i+2)!=NULL && *lindex(temp,i+2)!='|')
 {
 choicebutton[i] = XtVaCreateManagedWidget(lindex(temp,i+2), commandWidgetClass, mainbox, NULL);
 XtAddCallback(choicebutton[i], XtNcallback, (XtPointer)choiceHdl, NULL);
 i++;
 }
 if(lindex(temp,i+2)!=NULL && *lindex(temp,i+2)!='|')
 {
 choicebutton[i] = XtVaCreateManagedWidget(lindex(temp,i+2), commandWidgetClass, mainbox, NULL);
 XtAddCallback(choicebutton[i], XtNcallback, (XtPointer)choiceHdl, NULL);
 i++;
 }
 if(lindex(temp,i+2)!=NULL && *lindex(temp,i+2)!='|')
 {
 choicebutton[i] = XtVaCreateManagedWidget(lindex(temp,i+2), commandWidgetClass, mainbox, NULL);
 XtAddCallback(choicebutton[i], XtNcallback, (XtPointer)choiceHdl, NULL);
 i++;
 }
 if(lindex(temp,i+2)!=NULL && *lindex(temp,i+2)!='|')
 {
 choicebutton[i] = XtVaCreateManagedWidget(lindex(temp,i+2), commandWidgetClass, mainbox, NULL);
 XtAddCallback(choicebutton[i], XtNcallback, (XtPointer)choiceHdl, NULL);
 i++;
 }
 if(lindex(temp,i+2)!=NULL && *lindex(temp,i+2)!='|')
 {
 choicebutton[i] = XtVaCreateManagedWidget(lindex(temp,i+2), commandWidgetClass, mainbox, NULL);
 XtAddCallback(choicebutton[i], XtNcallback, (XtPointer)choiceHdl, NULL);
 i++;
 }
 if(lindex(temp,i+2)!=NULL && *lindex(temp,i+2)!='|')
 {
 choicebutton[i] = XtVaCreateManagedWidget(lindex(temp,i+2), commandWidgetClass, mainbox, NULL);
 XtAddCallback(choicebutton[i], XtNcallback, (XtPointer)choiceHdl, NULL);
 i++;
 }
 if(lindex(temp,i+2)!=NULL && *lindex(temp,i+2)!='|')
 {
 choicebutton[i] = XtVaCreateManagedWidget(lindex(temp,i+2), commandWidgetClass, mainbox, NULL);
 XtAddCallback(choicebutton[i], XtNcallback, (XtPointer)choiceHdl, NULL);
 i++;
 }
 if(lindex(temp,i+2)!=NULL && *lindex(temp,i+2)!='|')
 {
 choicebutton[i] = XtVaCreateManagedWidget(lindex(temp,i+2), commandWidgetClass, mainbox, NULL);
 XtAddCallback(choicebutton[i], XtNcallback, (XtPointer)choiceHdl, NULL);
 i++;
 }
 if(lindex(temp,i+2)!=NULL && *lindex(temp,i+2)!='|')
 {
 choicebutton[i] = XtVaCreateManagedWidget(lindex(temp,i+2), commandWidgetClass, mainbox, NULL);
 XtAddCallback(choicebutton[i], XtNcallback, (XtPointer)choiceHdl, NULL);
 i++;
 }
 XtRealizeWidget(top5);
 while(displayed) {
  XtAppNextEvent(ac5, &qevent);
  XtDispatchEvent(&qevent);
 }
 XFlush(display[5]);
}
#endif /* gtk */
#endif /* gui */

remote(char *host, int port, char *script, char *filename)
{
 int rsock, len, i, result;
 FILE *fr;
 char data[1024]="";
 char inchar;
 struct sockaddr_in address;
 rsock=socket(AF_INET, SOCK_STREAM, 0);
 if(rsock<0)
 {
#ifdef GUI
#ifndef GTK
   XFlush(display[2]);
#endif
   if(lang==0)   
   msgbox("error","Internal error: Socket failed.",25);
   else if(lang==1)
   msgbox("error","Erreur interne: Socket erreur.",25);
   else if(lang==2)
   msgbox("error","Error Interno: Fallo el Socket.",25);
#else
   if(lang==0)
   fprintf(stderr,"*** Internal error: Socket failed [%d].\n",errno);
   else if(lang==1)
   fprintf(stderr,"*** Erreur interne: Socket erreur. [%d].\n",errno);
   else if(lang==2)
   fprintf(stderr,"*** Error Interno: Fallo el Socket. [%d].\n",errno);
#endif
   exit(1);
 }
 address.sin_family = AF_INET;
 address.sin_addr.s_addr = inet_addr(host);
 address.sin_port = htons(port);
 len = sizeof(address);
 result = connect(rsock, (struct sockaddr *)&address, len);
 if(result==-1)
 {
#ifdef GUI
#ifndef GTK
  XFlush(display[2]);
#endif
  if(lang==0)
  msgbox("error","Script error: Can't connect to remote host.",30);
  else if(lang==1)
  msgbox("error","Erreur script: Incapable de me connecter.",30);
  else if(lang==2)
  msgbox("error","Error en Script: No se puede conectar a host remoto.",30);
#else
  if(lang==0)
  fprintf(stderr,"*** Script error: Can't connect to %s\n",host);
  else if(lang==1)
  fprintf(stderr,"*** Erreur script: Incapable de me connecter sur %s\n",host);
  else if(lang==2)
  fprintf(stderr,"*** Error en Script: No se puede conectar a host remoto %s\n",host);
#endif
  exit(1);
 }
 sprintf(data,"%s ;\n",script);
 write(rsock,data,sizeof(data));
 fr=fopen(filename,"w");
 while(strcasecmp(lindex(data,0),"--DATA--"))
 {
  bzero(data, 1024);
  for(i=0;(result=read(rsock,&inchar,1))!='\0';i++)
  {
   data[i]=inchar;
   if(inchar=='\n') break;
  }
  fputs(data,fr);
 }
 if(fr!=NULL) fclose(fr);
}

char *constat(char *option, int sockfd)
{
 char data[255];
 int optlen=sizeof(int),optval=1;
 if(!strcasecmp(option,"sendbuf")) getsockopt(sockfd, SOL_SOCKET, SO_SNDBUF, (char *)&optval, &optlen);
 else if(!strcasecmp(option,"recvbuf")) getsockopt(sockfd, SOL_SOCKET, SO_RCVBUF, (char *)&optval, &optlen);
 else if(!strcasecmp(option,"error")) getsockopt(sockfd, SOL_SOCKET, SO_ERROR, (char *)&optval, &optlen);
 else if(!strcasecmp(option,"type")) getsockopt(sockfd, SOL_SOCKET, SO_TYPE, (char *)&optval, &optlen);
 else optval=-1;
 sprintf(global_var,"%d",optval);
 return (char *)global_var;
}

int firewall()
{
 /* maybe this should be changed to use ipfw(4) instead...*/
 char src[25], dst[25], protocol[5], what[5], rule[5], result[100];
 int port;
 if(lindex(temp,1)==NULL || lindex(temp,2)==NULL || lindex(temp,3)==NULL || lindex(temp,4)==NULL || lindex(temp,5)==NULL || lindex(temp,6)==NULL)
 {
  lasterror=200;
  return -1;
 }
 if(strcasecmp(lindex(temp,1),"add") && strcasecmp(lindex(temp,1),"rem"))
 {
  lasterror=201;
  return -1;
 }
 if(strcasecmp(lindex(temp,2),"allow") && strcasecmp(lindex(temp,2),"deny"))
 {
  lasterror=201;
  return -1;
 }
 if(strcasecmp(lindex(temp,6),"icmp") && strcasecmp(lindex(temp,6),"tcp") && strcasecmp(lindex(temp,6),"udp") && strcasecmp(lindex(temp,6),"ALL"))
 {
  lasterror=201;
  return -1;
 }
 strcpy(src,lindex(temp,3));
 strcpy(dst,lindex(temp,4));
 strcpy(protocol,lindex(temp,6));
 if(!strcasecmp(lindex(temp,1),"add")) strcpy(what,"-i");
 if(!strcasecmp(lindex(temp,1),"rem")) strcpy(what,"-d");
 if(!strcasecmp(lindex(temp,2),"allow")) strcpy(rule,"accept");
 if(!strcasecmp(lindex(temp,2),"deny")) strcpy(rule,"deny");
 port = atoi(lindex(temp,5));
 if(!strcasecmp(src,"ALL")) strcpy(src,"0.0.0.0/0");
 else sprintf(src,"%s/28",lindex(temp,3));
 if(!strcasecmp(dst,"ALL")) strcpy(dst,"0.0.0.0/0");
 else sprintf(dst,"%s/28",lindex(temp,4));
 if(!strcasecmp(protocol,"ALL"))
 {
  if(port==0)
  {
   sprintf(result,"%s -I %s %s -P tcp -S %s -D %s\n",IPFW,what,rule,src,dst);
   sprintf(result,"%s -I %s %s -P udp -S %s -D %s\n",IPFW,what,rule,src,dst);
   sprintf(result,"%s -I %s %s -P icmp -S %s -D %s\n",IPFW,what,rule,src,dst);
  }
  else
  {
   sprintf(result,"%s -I %s %s -P tcp -S %s -D %s %d\n",IPFW,what,rule,src,dst,port); 
   sprintf(result,"%s -I %s %s -P udp -S %s -D %s %d\n",IPFW,what,rule,src,dst,port);
   sprintf(result,"%s -I %s %s -P icmp -S %s -D %s %d\n",IPFW,what,rule,src,dst,port);
  }
 }
 else
 {
  if(port==0) sprintf(result,"%s -I %s %s -P %s -S %s -D %s\n",IPFW,what,rule,protocol,src,dst);
  else sprintf(result,"%s -I %s %s -P %s -S %s -D %s %d\n",IPFW,what,rule,protocol,src,dst,port);
 }
 system(result);
}

int users(char in[1024][1024])
{
#ifdef POSIX
 struct passwd *pw;
 if(!strcasecmp(lindex(in[atoi(lindex2(temp,1))],0),"UID"))
 {
  pw = getpwuid(atol(lindex(in[atoi(lindex2(temp,1))],1)));
  if(pw!=NULL)
  sprintf(in[atoi(lindex(temp,2))],"%s %ld %ld %s %s ;",pw->pw_name,pw->pw_uid,pw->pw_gid,pw->pw_passwd,pw->pw_dir);
  else
  sprintf(in[atoi(lindex(temp,2))],"unknown -1 -1 unknown unknown ;");
 }
 if(!strcasecmp(lindex(in[atoi(lindex2(temp,1))],0),"NAME"))
 {
  pw = getpwnam(lindex(in[atoi(lindex2(temp,1))],1));
  if(pw!=NULL)
  sprintf(in[atoi(lindex(temp,2))],"%s %ld %ld %s %s ;",pw->pw_name,pw->pw_uid,pw->pw_gid,pw->pw_passwd,pw->pw_dir);
  else
  sprintf(in[atoi(lindex(temp,2))],"unknown -1 -1 unknown unknown ;");
 }
#endif
}

int des_file(int type, char in[1024][1024])
{
 char data[255];
 if(type==1)
 {
  if(lindex(in[atoi(lindex2(temp,1))],0)!=NULL && lindex(in[atoi(lindex2(temp,1))],1)!=NULL)
  {
   sprintf(data,"des -E %s %s.des -k %s",lindex(in[atoi(lindex2(temp,1))],0),lindex(in[atoi(lindex2(temp,1))],0),lindex(in[atoi(lindex2(temp,1))],1));
   system(data);
  }
 }
 else
 {
  if(lindex(in[atoi(lindex2(temp,1))],0)!=NULL && lindex(in[atoi(lindex2(temp,1))],1)!=NULL)
  {
   sprintf(data,"des -D %s.des %s -k %s",lindex(in[atoi(lindex2(temp,1))],0),lindex(in[atoi(lindex2(temp,1))],0),lindex(in[atoi(lindex2(temp,1))],1));
   system(data);
  }
 }
}
